;**********************************************************************************************
;** Elektronische Sanduhr de luxe (Version 1)		 	 			     **
;**								 			     **
;** 								 			     **
;** Entwickler: Buchgeher Stefan				 			     **
;** Entwicklungsbeginn der Software: 3. April 2003		 			     **
;** Funktionsfaehig seit: 30. Juni 2003  (die Grundfunktion) 				     **			
;** Letzte Bearbeitung: 21. November 2004		         			     **
;**********************************************************************************************

		List 	p=PIC16F874


;******************************** Register (in Registerbank 0) ********************************
IND			equ	0	;Register fr indirekte Adressierung
TMR0			equ	1	;Timer0-Register
PCL			equ	2	;Programmzaehler (Low-Byte)
STAT			equ	3	;Statusregister
FSR			equ	4	;FSR-Register
PORTA			equ	5	;PortA-Register
PORTB			equ	6	;PortB-Register
PORTC			equ	7	;PortC-Register
PORTD			equ	8	;PortD-Register
PORTE			equ	9	;PortE-Register
PCLATH			equ	0A	;Programmzaehler (High-Byte)
INTCON			equ	0B	;Interrupt-Register
PIR1			equ	0C	;PIR1-Register
PIR2			equ	0D	;PIR2-Register
RCSTA			equ	18	;Register zur Einstellung des USART-Empfaengers
TXREG			equ	19	;USART-Sendebuffer
RXREG			equ	1A	;USART-Empfangsbuffer


;******************************** Register (in Registerbank 1) ********************************
OPTREG			equ	1	;OPTION-Register
TRISA			equ	5	;Richtungsregister PortA
TRISB			equ	6	;Richtungsregister PortB
TRISC			equ	7	;Richtungsregister PortC
TRISD			equ	8	;Richtungsregister PortD
TRISE			equ	9	;Richtungsregister PortE
ADCON1			equ	1F	;Register fuer ADC
TXSTA			equ	18	;Register zur Einstellung des USART-Senders
SPBRG			equ	19	;Register zur Einstellung der USART-BAudrate


;******************************** Register (in Registerbank 2) ********************************
EEDATA			equ	0C	;EEPROM-Daten-Register
EEADR			equ	0D	;EEPROM-Adress-Register


;******************************** Register (in Registerbank 3) ********************************
EECON1			equ	0C	;EECON1-Register
EECON2			equ	0D	;EECON2-Register


;******************************** Eigene Register (in Registerbank 0) *************************
FLAGSISRHP		equ	21	;beinhaltet Botschaftsflags
ZAEHLERISR2MS		equ	22
;ZAEHLERISR4MS		equ	23
ZAEHLERISR10MS		equ	23
ZAEHLERISR1SEK		equ	24

ESUSTATUS		equ	25	;Sanduhr-Statusregister
					;  Bit 0: 1 ... Starttaste wurde gedrueckt, 
					;               Krner(LEDs) rieseln nach unten
					;  	  0 ... Starttaste nicht gedrueckt
					;  Bit 1: gesetzt: PAUSE-Taste gedrueckt  
					;  Bit 3: gesetzt: Zeit ist abgelaufen
 					;  Bit 4: gesetzt: Standby-Mode

ESULEDZAEHL		equ	27	;Zaehlvariable (51 bis 0) gibt die Aktuelle 
					;  POS-Nr der leuchtende LED an  
ESULEDAKTZUSTAND	equ	28
ESULEDZEITZW2ZUST0	equ	29	;Diese Register beinhalten die berechnete
ESULEDZEITZW2ZUST1	equ	2A	;  Zeit zwischen 2 LED-Zustaenden (24 bit-Zahl)
ESULEDZEITZW2ZUST2	equ	2B
ESULEDZAEHLZW2ZUST0	equ	2C	;Diese Zaehlregister zaehlen die Zeit bis 
ESULEDZAEHLZW2ZUST1	equ	2D	;  zum naechsten Zustandswechsel der LEDs
ESULEDZAEHLZW2ZUST2	equ	2E

ESUZEITSTATUS		equ	2F
ESUZEITAKTSPALTE	equ	33	;Anzahl der Zeilen
ESUZEITGESMIN		equ	34
ESUZEITGESSEK		equ	35
ESUZEITABMIN		equ	36
ESUZEITABSEK		equ	37
ESUZEITBLEIBMIN		equ	38
ESUZEITBLEIBSEK		equ	39
ESUZEITZAEHLSEK		equ	3A
 
ESUTASTENE		equ	3B
ESUTASTENALT		equ	3C

ESUSTANDBYSEK		equ	3D
ESUSTANDBYMIN		equ	3E
 
ESUKONFIG		equ	3F	;Konfigurationsregister
ESUKONFIGSAUS1		equ	40	;Konfigurationsregister (Schaltausgang 1)
ESUKONFIGSAUS2		equ	41	;Konfigurationsregister (Schaltausgang 2)

ESUHILFSREGISTER	equ	50 	;Beinhaltet diverse Hilfsflags

INKRSTATUS		equ	54
 
DCFSTATUS		equ	55	;DCF-Statusregister  
DCFPULS			equ	56	;Impulszeit des DCF-Impulses
DCFPAUSE		equ	57	;Zeit zwischen 2 DCF-Impulsen
DCFTELEGRAMM1		equ	58	;in diese Register wird das DCF-Telegramm	  
DCFTELEGRAMM2		equ	59	;  im Sekunden-Takt eingelesen. Beginnt eine 		
DCFTELEGRAMM3		equ	5A	;  neue Minute, so werden diese Register 
DCFTELEGRAMM4		equ	5B	;  ausgewertet, und in die entsprechenden
DCFTELEGRAMM5		equ	5C	;  DCF-Zeit-Datums-Register kopiert (z.B. in das
DCFTELEGRAMM6		equ	5D	;  Register DCFMINBCD)
DCFTELEGRAMM7		equ	5E	;Reserve
DCFTELEGRAMM8		equ	5F	;Reserve
DCFMINBCD		equ	60	;Beinhaltet die aktuelle dekodierte Minute (BCD-Format)
DCFSTDBCD		equ	61	;Beinhaltet die aktuelle dekodierte Stunde (BCD-Format)
DCFTAGBCD		equ	62	;Beinhaltet den aktuell dekodierten Tag (BCD-Format)
DCFMONBCD		equ	63	;Beinhaltet den aktuell dekodierten Monat (BCD-Format)
DCFJAHRBCD		equ	64	;Beinhaltet das aktuell dekodierte Jahr (BCD-Format)
DCFWOCHENTAG		equ	65	;Beinhaltet den aktuell dekodierten Wochentag 
					;  (1=Montag, 2=Dienstag, usw, 7=Sonntag)
DCFZUSATZINFOS		equ	66	;Beinhaltet Zusatzinformationen (Sommer/Winterzeit,
					;  Reserveantenne usw.)
DCFMINALT		equ	67	;In den Registern DCFxxxALT befinden sich die Uhrzeit-
DCFSTDALT		equ	68	;  und Datumsinfos der vorangegangenen Minute. Diese
DCFTAGALT		equ	69	;  werden zur Ueberpruefung des neuen DCF-Telegramms
DCFMONALT		equ	6A	;  benoetigt
DCFJAHRALT		equ	6B		
DCFWTAGALT		equ	6C

UHRSEKUNDE		equ	6D	;Sekundenzaehler der inneren quarzgesteuerten Uhr
UHRMINUTE		equ	6E	;Minutenzaehler der inneren quarzgesteuerten Uhr, wird
					;  mit jedem gueltigen DCF-dekod. Wert syncronisiert
UHRSTUNDE		equ	6F	;Stundenzaehler der inneren quarzgesteuerten Uhr, wird
					;  mit jedem gueltigen DCF-dekod. Wert syncronisiert

SAUS1MODE3ZAEHL		equ	70	;Zaehlregister fuer Mode 3 (Schaltausgang 1)
SAUS2MODE3ZAEHL		equ	71	;Zaehlregister fuer Mode 3 (Schaltausgang 2)

TEMP1			equ	77	;Allgemeines Hilfsregister 1
TEMP2			equ	78	;Allgemeines Hilfsregister 2
TEMP3			equ	79	;Allgemeines Hilfsregister 3			
TEMP4			equ	7A	;Allgemeines Hilfsregister 4
TEMP5			equ	7B	;Allgemeines Hilfsregister 5
TEMP6			equ	7C	;Allgemeines Hilfsregister 6

ISR_FSR_TEMP		equ	7D	;Zwischenspeicher des FSR-Register der ISR
ISR_STAT_TEMP		equ	7E	;Zwischenspeicher des Statusregister der ISR
ISR_w_TEMP		equ	7F	;Zwischenspeicher des Arbeitsregister der ISR
					;  ACHTUNG: Das Register ISR_w_TEMP muss in 
					;  allen verwendeten Registerbaenken definiert		
					;  werden!


;******************************** Eigene Register (in Registerbank 1) *************************
ESULEDPOS1		equ	20	;die folgenden 51 Register beinhalten die 
ESULEDPOS2		equ	21	;  aktuellen "Adressen" der aktiven 
ESULEDPOS3		equ	22	;  (leuchtenden) LEDs
ESULEDPOS4		equ	23
ESULEDPOS5		equ	24
ESULEDPOS6		equ	25
ESULEDPOS7		equ	26
ESULEDPOS8		equ	27
ESULEDPOS9		equ	28
ESULEDPOS10		equ	29
ESULEDPOS11		equ	2A
ESULEDPOS12		equ	2B
ESULEDPOS13		equ	2C
ESULEDPOS14		equ	2D
ESULEDPOS15		equ	2E
ESULEDPOS16		equ	2F
ESULEDPOS17		equ	30
ESULEDPOS18		equ	31
ESULEDPOS19		equ	32
ESULEDPOS20		equ	33
ESULEDPOS21		equ	34
ESULEDPOS22		equ	35
ESULEDPOS23		equ	36
ESULEDPOS24		equ	37
ESULEDPOS25		equ	38
ESULEDPOS26		equ	39
ESULEDPOS27		equ	3A
ESULEDPOS28		equ	3B
ESULEDPOS29		equ	3C
ESULEDPOS30		equ	3D
ESULEDPOS31		equ	3E
ESULEDPOS32		equ	3F
ESULEDPOS33		equ	40
ESULEDPOS34		equ	41
ESULEDPOS35		equ	42
ESULEDPOS36		equ	43
ESULEDPOS37		equ	44
ESULEDPOS38		equ	45
ESULEDPOS39		equ	46
ESULEDPOS40		equ	47
ESULEDPOS41		equ	48
ESULEDPOS42		equ	49
ESULEDPOS43		equ	4A
ESULEDPOS44		equ	4B
ESULEDPOS45		equ	4C
ESULEDPOS46		equ	4D
ESULEDPOS47		equ	4E
ESULEDPOS48		equ	4F
ESULEDPOS49		equ	50
ESULEDPOS50		equ	51
ESULEDPOS51		equ	52

ESUZEITANZ43		equ	53	;3. Spalte der 4. Ziffer
ESUZEITANZ42		equ	54	;2. Spalte der 4. Ziffer
ESUZEITANZ41		equ	55	;1. Spalte der 4. Ziffer
ESUZEITANZ33		equ	56	;3. Spalte der 3. Ziffer
ESUZEITANZ32		equ	57	;2. Spalte der 3. Ziffer
ESUZEITANZ31		equ	58	;1. Spalte der 3. Ziffer
ESUZEITANZ23		equ	59	;3. Spalte der 2. Ziffer
ESUZEITANZ22		equ	5A	;2. Spalte der 2. Ziffer
ESUZEITANZ21		equ	5B	;1. Spalte der 2. Ziffer
ESUZEITANZ13		equ	5C	;3. Spalte der 1. Ziffer
ESUZEITANZ12		equ	5D	;2. Spalte der 1. Ziffer
ESUZEITANZ11		equ	5E	;1. Spalte der 1. Ziffer

ISR_w_TEMP		equ	7F	;Zwischenspeicher des Arbeitsregister der ISR
					;  ACHTUNG: Das Register ISR_w_TEMP muss in 
					;  allen verwendeten Registerbaenken definiert		
					;  werden!

 
;******************************** Bits in Registern der Registerbank 0 ************************
;Register STAT 
C			equ	0	;Carrybit  
Z			equ	2	;Zerobit  
RP0			equ	5	;Seitenauswahlbit 0  
RP1			equ	6	;Seitenauswahlbit 1  

;Register INTCON
T0IF			equ	2	;Timer0-Interruptflag  
GIE			equ	7	;Interruptfreigabeflag

;Register PIR1
TXIF			equ	4	;USART-Sender-Fertig-Flag

;Register PIR2
EEIF			equ	4	;EEPROM-Fertig-Flag


;******************************** Bits in Registern der Registerbank 1 ************************
;Register TXSTA
TRMT			equ	1

 
;******************************** Bits in Registern der Registerbank 3 ************************
;Register EECON1
RD			equ	0
WR			equ	1
WREN			equ	2	
EEPGD			equ	7


;******************************** Bits in den eigenen Registern der Registerbank 0 ************
;FLAGSISRHP
FLAG2MSEK		equ	0
;FLAG4MSEK		equ	1
FLAG10MSEK		equ	2
FLAG1SEK		equ	3
FLAG1SEKRIESELN		equ	4
FLAGNAECHSTZUST		equ	5

;ESUKONFIG
BEEPEINAUS		equ	6
LSEINAUS		equ	7

;ESUTASTENE, ESUTASTENALT 
TASTESELZEIT		equ	1
TASTEPAUSE		equ	2
TASTESTART		equ	3
TASTESTOP		equ	4
INKR1			equ	0
INKR2			equ	5

;INKRSTATUS
INKRLINKS		equ	6
INKRRECHTS		equ	7
INKR1ALT		equ	0	;Achtung: muessen die selben Bitzuordnungen 
INKR2ALT		equ	5	;  wie am Port D besitzen
  
;Register DCFSTATUS
DCFPORTNEU		equ	0	;Akt. Zustand DCF-Porteingang 
DCFPORTALT		equ	1	;Vorhergehender Zustand am DCF-Porteingang
DCFNEUESEK		equ	2	;gesetzt, wenn neue Sekunde begonnen
DCFNEUEMIN		equ	3	;gesetzt, wenn neue Minute begonnen
DCFLOW			equ	4	;gesetzt, wenn Low-Signal erkannt
DCFHIGH			equ	5	;gesetzt, wenn High-Signal erkannt
DCFFEHLER		equ	6	;gesetzt, wenn ein Fehler erkannt
DCFSYNC			equ	7	;gesetzt, wenn Uhr mit DCF synchronisiert

;Register DCFZUSATZINFOS
DCFRESANT		equ	0	;Reserveantenne
DCFSOMWIN		equ	1	;Vorankuendigung der Sommer/Winterzeit-Umstellung
DCFSOMMER		equ	2	;Sommerzeit
DCFWINTER		equ	3	;Winterzeit
DCFSCHALTSEK		equ	4	;Vorankuendigung einer zusaetzliche Schaltsekunde


;******************************** Portbelegung  ***********************************************
;Port A
SCHALTAUSGANG1		equ	0
SCHALTAUSGANG2		equ	1
ZEIT_CLK		equ	2
ZEIT_DATA		equ	3
EN_LED			equ	4
EN_ZEIT			equ	5

;Port D
DCFINPORT		equ	PORTD
;DCFINTRIS		equ	TRISD
DCFIN			equ	7 


;******************************** Konstanten **************************************************
LED1			equ 	b'11110000'	;"Adresse" von LED D1
LED2			equ	b'11100000'	;"Adresse" von LED D2
LED3			equ	b'11000000'	;"Adresse" von LED D3, usw.	
LED4			equ	b'10100000'
LED5			equ	b'10000000'
LED6			equ	b'11111000'
LED7			equ	b'11010000'
LED8			equ	b'10110000'
LED9			equ	b'10010000'
LED10			equ	b'10000010'
LED11			equ	b'11101000'
LED12			equ	b'11001000'
LED13			equ	b'10101000'
LED14			equ	b'10001000'
LED15			equ	b'11110100'
LED16			equ	b'11011000'
LED17			equ	b'10111000'
LED18			equ	b'10011000'
LED19			equ	b'10010010'
LED20			equ	b'11100100'
LED21			equ	b'11000100'
LED22			equ	b'10100100'
LED23			equ	b'10000100'
LED24			equ	b'11111100'
LED25			equ	b'11010100'
LED26			equ	b'10110100'
LED27			equ	b'10010100'
LED28			equ	b'10100110'
LED29			equ	b'11101100'
LED30			equ	b'11001100'
LED31			equ	b'10101100'
LED32			equ	b'10001100'
LED33			equ	b'11110010'
LED34			equ	b'11011100'
LED35			equ	b'10111100'
LED36			equ	b'10011100'
LED37			equ	b'10110110'
LED38			equ	b'11100010'
LED39			equ	b'11000010'
LED40			equ	b'10100010'
LED41			equ	b'10001010'
LED42			equ	b'11110110'
LED43			equ	b'11010010'
LED44			equ	b'10110010'
LED45			equ	b'10011010'
LED46			equ	b'11100110'
LED47			equ	b'11001010'
LED48			equ	b'10101010'
LED49			equ	b'11010110'
LED50			equ	b'10111010'
LED51			equ	b'11000110'
LED52			equ	b'11010001'
LED53			equ	b'10110001'
LED54			equ	b'11100001'
LED55			equ	b'11000001'
LED56			equ	b'10100001'
LED57			equ	b'11110001'
LED58			equ	b'11011001'
LED59			equ	b'10111001'
LED60			equ	b'10010001'
LED61			equ	b'10000110'
LED62			equ	b'11101001'
LED63			equ	b'11001001'
LED64			equ	b'10101001'
LED65			equ	b'10000001'
LED66			equ	b'11111001'
LED67			equ	b'11010101'
LED68			equ	b'10110101'
LED69			equ	b'10010101'
LED70			equ	b'10010110'
LED71			equ	b'11100101'
LED72			equ	b'11000101'
LED73			equ	b'10100101'
LED74			equ	b'10000101'
LED75			equ	b'11110101'
LED76			equ	b'11010011'
LED77			equ	b'10110011'
LED78			equ	b'10010011'
LED79			equ	b'10011001'
LED80			equ	b'11100011'
LED81			equ	b'11000011'
LED82			equ	b'10100011'
LED83			equ	b'10000011'
LED84			equ	b'11110011'
LED85			equ	b'11011011'
LED86			equ	b'10111011'
LED87			equ	b'10011011'
LED88			equ	b'10001001'
LED89			equ	b'11101011'
LED90			equ	b'11001011'
LED91			equ	b'10101011'
LED92			equ	b'10001011'
LED93			equ	b'11111011'
LED94			equ	b'11010111'
LED95			equ	b'10110111'
LED96			equ	b'10010111'
LED97			equ	b'11110111'
LED98			equ	b'11100111'
LED99			equ	b'11000111'
LED100			equ	b'10100111'
LED101			equ	b'10000111'

ZUSTANZ			equ	.227		;Anzahl der Zustnde
LEDANZAKTIV		equ	.51 		;Anzahl der leuchtenden LEDs
 
;KONSTISR1SEK		equ	.250
KONSTISR1SEK		equ	.100
KONSTISR2MS		equ	.8
;KONSTISR2MS		equ	.9
;KONSTISR4MS		equ	.2
KONSTISR10MS		equ	.5

KONSTMUL1		equ	.17		;Multiplikationsfaktor (vor dem Komma)
KONSTMUL2		equ	.153		;Multiplikationsfaktor (nach dem Komma)
						; =0,6 * 256
						; -> Multiplikationsfaktor: 17.6

;KONSTMUL1		equ	.19		;Multiplikationsfaktor (vor dem Komma)
;KONSTMUL2		equ	.209		;Multiplikationsfaktor (nach dem Komma)
						; =0,82 * 256
						; -> Multiplikationsfaktor: 19.8

KONSTTABWIRDERSETZT	equ	.6		;
KONSTTABNEUELED		equ	.7		;


KONSTDCFLMIN		equ	.8
KONSTDCFLMAX		equ	.12
KONSTDCFHMIN		equ	.16
KONSTDCFHMAX		equ	.24
KONSTDCFNEUEMIN		equ	.100


;******************************** Ziele der Registeroperationen *******************************
w			equ	0		;w ist Zielregister
f			equ	1		;f ist Zielregister


;******************************** Masken ******************************************************
MASKEINKR		equ	b'00100001'	;zum Ausmaskieren der Inkrementalgeber-
						;  Eingaenge

 
;******************************** Makros ******************************************************
;Umschalten zu Registerbank 0
bank0		MACRO
		bcf	STAT,RP0
		bcf	STAT,RP1
		ENDM

;Umschalten zu Registerbank 1
bank1		MACRO
		bsf	STAT,RP0
		bcf	STAT,RP1
		ENDM

;Umschalten zu Registerbank 2
bank2		MACRO
		bcf	STAT,RP0
		bsf	STAT,RP1
		ENDM

;Umschalten zu Registerbank 3
bank3		MACRO
		bsf	STAT,RP0
		bsf	STAT,RP1
		ENDM

;Bit invertieren (entspricht dem Befehl btg bei PIC17/18)
btg		MACRO	FILE,BIT
		local	SETBIT
		btfss	FILE,BIT
		goto	SETBIT
		bcf	FILE,BIT
		btfsc	FILE,BIT
SETBIT		bsf	FILE,BIT
		ENDM


;******************************** Konfigurations-Bits *****************************************
_CP_ALL              	equ     h'0FCF'
_CP_HALF               	equ   	h'1FDF'
_CP_UPPER_256          	equ     h'2FEF'
_CP_OFF                 equ     h'3FFF'

_DEBUG_ON               equ     h'37FF'
_DEBUG_OFF              equ     h'3FFF'

_WRT_ENABLE_ON          equ     h'3FFF'
_WRT_ENABLE_OFF         equ     h'3DFF'

_CPD_ON                 equ     h'3EFF'
_CPD_OFF                equ     h'3FFF'

_LVP_ON                 equ     h'3FFF'
_LVP_OFF                equ     h'3F7F'

_BODEN_ON               equ     h'3FFF'
_BODEN_OFF              equ     h'3FBF'

_PWRTE_OFF              equ     h'3FFF'
_PWRTE_ON               equ     h'3FF7'

_WDT_ON                 equ     h'3FFF'
_WDT_OFF                equ     h'3FFB'

_LP_OSC                 equ     h'3FFC'
_XT_OSC                 equ     h'3FFD'
_HS_OSC                 equ     h'3FFE'
_RC_OSC                 equ     h'3FFF'

	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_OFF & _HS_OSC & _WRT_ENABLE_ON & _LVP_OFF & _DEBUG_OFF & _CPD_OFF 


		ORG	0x000
		goto	Beginn
		ORG	0x004
		goto	ISR
	

;******************************** Tabellen ****************************************************
		 
;**********************************************************************************************
;** Tabelle TABZIFFERN:		    					     		     **
;** blabla		     **
;**********************************************************************************************

;alter Zeichensatz
;TABZIFFERN	addwf	PCL,f
;	 	nop
;		dt	.17,.14,.17		;0
;		dt	.23,.0,.31		;1
;		dt	.12,.10,.22		;2
;		dt	.10,.10,.21		;3
;		dt	.25,.21,.0		;4
;		dt	.2,.10,.13		;5
;		dt	.17,.10,.29		;6
;		dt	.15,.8,.7		;7
;		dt	.21,.10,.21		;8
;		dt	.23,.10,.17		;9


;neuer Zeichensatz
TABZIFFERN	addwf	PCL,f
	 	nop
		dt	.17,.14,.17		;0
		dt	.22,.0,.30		;1
		dt	.12,.10,.22		;2
		dt	.14,.10,.21		;3
		dt	.25,.21,.0		;4
		dt	.2,.10,.13		;5
		dt	.17,.10,.29		;6
		dt	.15,.12,.19		;7
		dt	.21,.10,.21		;8
		dt	.23,.10,.17		;9


;******************************** ISR - Timer0 ************************************************

;**********************************************************************************************
;** Interrupt Service Routine:    					     		     **
;** w-Register (=Arbeitsregister) und Status-Register zwischenspeichern. 		     **
;**								 			     **
;**  											     **
;** Das Timer-Interrupt-Flag T0IF wieder lschen, und das w- bzw. Status-Register wiederher- **
;** stellen.                          							     **
;**********************************************************************************************
ISR
PUSH	 	movwf	ISR_w_TEMP		;w-Register retten
		swapf	STAT,w			;Statusregister
		bank0				;  in Registerseite 0
		movwf	ISR_STAT_TEMP		;  retten
		movf	FSR,w			;FSR-Register retten
		movwf	ISR_FSR_TEMP
 
		;Beginn der eigentlichen ISR-Routine
	
 		call	LEDANZEIGE
		call	LAUTSPRECHER
		call	SAUSMODE3
		 
	 
 		decfsz	ZAEHLERISR2MS,f	
		goto	ISRWEITER2

		bsf	FLAGSISRHP,FLAG2MSEK	;Botschaftsflag setzen
 		movlw	KONSTISR2MS
		movwf	ZAEHLERISR2MS
		
;		decfsz	ZAEHLERISR4MS,f	
		decfsz	ZAEHLERISR10MS,f	
		goto	ISRWEITER2

;		bsf	FLAGSISRHP,FLAG4MSEK	;Botschaftsflag setzen
		bsf	FLAGSISRHP,FLAG10MSEK	;Botschaftsflag setzen
; 		movlw	KONSTISR4MS
		movlw	KONSTISR10MS
;		movwf	ZAEHLERISR4MS
		movwf	ZAEHLERISR10MS

		decfsz	ZAEHLERISR1SEK,f
		goto	ISRWEITER1

		bsf	FLAGSISRHP,FLAG1SEK	;Botschaftsflag setzen
 		movlw	KONSTISR1SEK
		movwf	ZAEHLERISR1SEK	

		;Verrieselungszeit und Zaehler fuer Zustandswechsel
		
ISRWEITER1	btfss	ESUSTATUS,0
		goto	ISRWEITER2
		btfsc	ESUSTATUS,1
		goto	ISRWEITER2

		; 1. Verrieselungszeit
		decfsz	ESUZEITZAEHLSEK,f
		goto	ISRWEITER2

		bsf	FLAGSISRHP,FLAG1SEKRIESELN	;Botschaftsflag setzen
 		movlw	KONSTISR1SEK
		movwf	ESUZEITZAEHLSEK		

		; 2. Zaehler fuer Zustandswechsel
ISRWEITER2 	btfss	ESUSTATUS,0
		goto	ISRENDE
		btfsc	ESUSTATUS,1
		goto	ISRENDE

		decfsz	ESULEDZAEHLZW2ZUST0,f
		goto	ISRENDE

		decfsz	ESULEDZAEHLZW2ZUST1,f
		goto	ISRENDE

		decfsz	ESULEDZAEHLZW2ZUST2,f
		goto	ISRENDE

		movf	ESULEDZEITZW2ZUST0,w
		movwf	ESULEDZAEHLZW2ZUST0	

		movf	ESULEDZEITZW2ZUST1,w
		movwf	ESULEDZAEHLZW2ZUST1

		movf	ESULEDZEITZW2ZUST2,w
		movwf	ESULEDZAEHLZW2ZUST2

		bsf	FLAGSISRHP,FLAGNAECHSTZUST ;Botschaftsflag setzen

ISRENDE	
 		;Ende der eigentlichen ISR-routine

		bcf	INTCON,T0IF		;T0-Interruptflag loeschen
		
POP		movf	ISR_FSR_TEMP,w	
		movwf	FSR			;FSR-Register wiederherstellen
		swapf	ISR_STAT_TEMP,w		;Status-Register  
		movwf	STAT			;  und
		swapf	ISR_w_TEMP,f		;  w-Register
		swapf	ISR_w_TEMP,w		;  wieder herstellen

		retfie				


;******************************** Unterprogramme **********************************************		

;**********************************************************************************************
;** INIT										     **
;** Aufgabe:										     **
;**     Initialisierung des Prozessor:				 			     **
;**	    + TMR0 mit Vorteiler (Vorteiler = 4)					     **
;**         + Ports: Port A: Ausgang, auf Digital I/O umstellen				     **
;**		     Port B: Ausgang				 			     **
;**		     Port C: Pin 7: Eingang 						     **
;**		 	     Pins 0 und 6: Ausgang					     **
;**			     Pins 1 bis 5: Reserve					     **
;**		     Port D: Eingang				 			     **
;**	 	     Port E: Ausgang, auf Digital I/O umstellen				     **
;**	    + div. Register vorbelegen							     **
;**         + Konfiguration und zuletzt eingestellte Zeit aus internen EEPROM auslesen und   **
;**	      in die jeweiligen Register kopieren					     **	
;**										             **
;** 	      Auszulesende Daten:							     **
;**		EEPROM-									     **
;**     	Speicherstelle	Registername	Bemerkung			     	     **
;**			0	ESUZEITGESSEK 	zuletzt eingestellte Zeit (Sekunden)	     **
;**			1	ESUZEITGESMIN 	zuletzt eingestellte Zeit (Minuten)	     **
;**			2	ESUKONFIG	Konfigurationsregister			     **
;**			3	ESUKONFIGSAUS1	Konfigurationsregister (Schaltausgang 1)     **	
;**			4	ESUKONFIGSAUS2	Konfigurationsregister (Schaltausgang 2)     **		
;**********************************************************************************************
INIT	
		clrf	TMR0			;Timer0 auf 0 voreingestellt

		clrf	PORTA			;Ausgaenge von PORTA loeschen

		bank1				;Registerseite 1
 		
; 		movlw	b'00000001'		;Timer 0: interner Takt, Vorteiler = 4 
		movlw	b'00001000'
 		movwf	OPTREG

 		movlw	b'00000110'		;alle ADC-Eingaenge auf 
		movwf	ADCON1			;  digital I/O umschalten
		
		movlw	b'00000000'
		movwf	TRISA			;Port A: Ausgang
		movlw	b'00000000'
		movwf	TRISB			;Port B: Ausgang
		movlw	b'10000000'		;Port C: Pin 7: Eingang
		movwf	TRISC			;        Pins 2 und 6: Ausgang
						;        Pins 1 bis 5: Reserve 
		movlw	b'11111111'	
		movwf	TRISD			;Port D: Eingang
		movlw	b'000'
		movwf	TRISE			;Port E: Ausgang

;		bsf	DCFINTRIS,DCFIN		;DCFIN als Eingang definieren

		movlw	b'00100100'		;USART (RS232) initialisieren  
		movwf	TXSTA			;  (Teil 1 in Registerseite 1 = Sender)
		
		movlw	.59			;USART (RS232) initialisieren 
		movwf	SPBRG			;  (Teil 2 in Registerseite 1 = Baudrate)
						;  19200 Baud -> SPBRG mit 59d laden
	
		bank0				;Registerseite 0

		movlw	b'10010000'		;USART (RS232) initialisieren 
		movwf	RCSTA			;  (Teil 3 in Registerseite 0 = Empfaenger)

 		movlw	LEDANZAKTIV		;Register ESUZAEHLLED mit der Konstanten
		movwf	ESULEDZAEHL		;  LEDANZAKTIV (=51 laden)

 		bcf 	PORTA,EN_LED		;LED-Anzeige freigeben
		bcf	PORTA,EN_ZEIT		;Zeitanzeige freigeben
		bsf	PORTA,SCHALTAUSGANG1	;Schaltausgang 1 initialisieren (setzen)
		bsf	PORTA,SCHALTAUSGANG2	;Schaltausgang 2 initialisieren (setzen)
		
 		movlw	.6
		movwf	ESUZEITAKTSPALTE

		movlw	KONSTISR2MS
		movwf	ZAEHLERISR2MS
 
;		movlw	KONSTISR4MS
;		movwf	ZAEHLERISR4MS	

		movlw	KONSTISR10MS
		movwf	ZAEHLERISR10MS	

		movlw	KONSTISR1SEK
		movwf	ZAEHLERISR1SEK
		movwf	ESUZEITZAEHLSEK

		movlw	b'00101011'		;Tasten START, SELPOS und
						;  Drehimpulsgeber freigeben
		movwf	ESUTASTENE		;  Tasten STOP und PAUSE sperren

		clrf	ESUTASTENALT
		
		movf	PORTD,w			;den aktuellen Zustand von Port D einlesen ...
		andlw	MASKEINKR		;... die Bits des Inkrementalgebers ...
		movwf	INKRSTATUS		;... ausmaskieren und in INKRSTATUS sichern

		movlw	b'00011000'
		movwf	ESUZEITSTATUS

		clrf	ESUSTATUS		;Sanduhrstatusregister loeschen
		clrf	ESUZEITABSEK		;Die Zeitregister abgelauene Zeit und
		clrf	ESUZEITABMIN	
		clrf	ESUZEITBLEIBSEK		;  verbleibende Zeit loeschen
		clrf	ESUZEITBLEIBMIN	
		clrf	ESUHILFSREGISTER 	;Hilfsregister loeschen

		clrf	DCFSTATUS		;DCF-Statusregister (DCFSTATUS) initialisieren  
		bsf	DCFSTATUS,DCFFEHLER	;  Fehlerflag setzen, alle anderen Flags 
						;  loeschen
	 
		btfsc	DCFINPORT,DCFIN		;Pegel von DCFIN einlesen und im Flag 
		bsf	DCFSTATUS,DCFPORTNEU	;  DCFPORTNEU des Register DCFSTATUS sichern

		clrf	UHRSEKUNDE		;Sekundenzaehler initialisieren (mit 0)
		clrf	UHRMINUTE		;Minutenzaehler initialisieren (mit 0)
		clrf	UHRSTUNDE		;Stundenzaehler initialisieren (mit 0)
 		
		movlw	.99
		movwf	DCFMINALT 		;Vergleichsregister initialisieren (mit 99)
		movwf	DCFSTDALT	 	;Vergleichsregister initialisieren (mit 99)
		movwf	DCFTAGALT 		;Vergleichsregister initialisieren (mit 99)
		movwf	DCFMONALT	 	;Vergleichsregister initialisieren (mit 99)
		movwf	DCFJAHRALT		;Vergleichsregister initialisieren (mit 99)
		movwf	DCFWTAGALT	 	;Vergleichsregister initialisieren (mit 99)

		movlw	.00			;zuletzt eingestellte Zeit (Sekunden)
		call	EEPROMLESEN		;  aus internem EEPROM auslesen
		movwf	ESUZEITGESSEK		;  und in Register ESUZEITGESSEK kopieren  
		sublw	.59			;  befindet sich im EEPROM ein ungueltiger
		btfss	STAT,C			;  Sekundenwert (>59) das soeben eingelesenen
		clrf	ESUZEITGESSEK		;  Register ESUZEITGESSEK loeschen

		movlw	.01			;zuletzt eingestellte Zeit (Minuten)
		call	EEPROMLESEN		;  aus internem EEPROM auslesen
		movwf	ESUZEITGESMIN		;  und in Register ESUZEITGESMIN kopieren
		sublw	.99			;  befindet sich im EEPROM ein ungueltiger
		btfss	STAT,C			;  Minutenwert (>99) das soeben eingelesenen
		clrf	ESUZEITGESMIN		;  Register ESUZEITGESMIN loeschen 

		movlw	.02			;Konfigurationsdaten
		call	EEPROMLESEN		;  aus internem EEPROM auslesen
		movwf	ESUKONFIG		;  und in das Register ESUKONFIG kopieren
		andlw	b'00001111'
		movwf	ESUSTANDBYMIN
		clrf	ESUSTANDBYSEK

		movlw	.03			;Konfigurationsdaten (Schaltausgang 1)
		call	EEPROMLESEN		;  aus internem EEPROM auslesen
		movwf	ESUKONFIGSAUS1		;  und in das Register ESUKONFIGSAUS1 kopieren

		movlw	.04			;Konfigurationsdaten (Schaltausgang 2)
		call	EEPROMLESEN		;  aus internem EEPROM auslesen
		movwf	ESUKONFIGSAUS2		;  und in das Register ESUKONFIGSAUS2 kopieren


		call	ZEITAUSWAHL


;voruebergehend - zum Testen - Start

 

;voruebergehend - zum Testen - Ende
		return

;******************************** EEPROM-Routinen *********************************************

;**********************************************************************************************
;** EEPROMLESEN										     **
;** Aufgabe:										     **
;**     Die durch das Arbeitsregister (w-Register) adressierte EEPROM-Speicherstelle aus-    **
;**     lesen. Den ausgelesenen Wert wieder in das Arbeitsregister (w-Register) schreiben.   **
;**											     **
;** Achtung:										     **
;**     Die Registerseite wird veraendert! Beim Verlassen des Unterprogrammes befindet sich  **
;**	der Controller in Registerseite 0.						     **
;**********************************************************************************************		
EEPROMLESEN	bank2				;Registerseite 2
		movwf	EEADR			;die im w-Register enthaltene auszulesende
						;  EEPROM-Adresse in das Register EEADR laden

		bank3				;Registerseite 3
		bcf	EECON1,EEPGD		;Dem Controller einen EEPROM-Lesezugriff 
						;  mitteilen und  
		bsf	EECON1,RD		;  diesen Lesezugriff starten
		
		bank2				;Registerseite 2
		movf	EEDATA,w		;Im Register EEDATA befindet sich nun der
						;  auszulesende Wert. Diesen Wert in das
						;  w-Register kopieren
		bank0
		return 


;**********************************************************************************************
;** EEPROMSCHREIBEN									     **
;** Aufgabe:										     **
;**     Die im Register TEMP2 befindliche Information in das durch das Register TEMP1        **
;** 	addressierte EEPROM schreiben							     **
;**											     **
;** Achtung:										     **
;**     Die Registerseite wird veraendert! Beim Verlassen des Unterprogrammes befindet sich  **
;**	der Controller in Registerseite 0.						     **
;**											     **
;** Anmerkung:										     **
;**     Die temporaeren Register TEMP1 und TEMP2 dienen hier als Uebergabeparemeter 	     **
;**********************************************************************************************		
EEPROMSCHREIBEN	movf	TEMP1,w			;TEMP1 beinhaltet die Adresse der zu 
						;  schreibende Info,
		bank2				;  diese in das Register EEADR kopieren
		movwf	EEADR			;  (EEADR befindet sich in Registerbank 2)	

		bank0				;Registerseite 0
		movf	TEMP2,w			;TEMP2 beinhaltet die zu schreibende Info,
		bank2				;  diese in das Register EEDATA kopieren
		movwf	EEDATA			;  (EEDATA befindet sich in Registerbank 2)	

		bank3				;Registerseite 3
		bcf	EECON1,EEPGD		;Dem Controller einen EEPROM-Schreibzugriff 
						;  mitteilen und  
		bsf	EECON1,WREN		;  diesen Schreibzugriff erlauben
		bcf	INTCON,GIE		;Alle Interrupts verbieten		
 	
		;Die folgenden 5 Befehle duerfen nicht veraendert werden!
		movlw	0x55
		movwf	EECON2			;Den Wert 55h in das Register EECON2 schreiben
		movlw	0xAA 
		movwf	EECON2			;Den Wert AAh in das Register EECON2 schreiben
		bsf	EECON1,WR		;Den Schreibzugriff starten

		bsf	INTCON,GIE		;Interrupts wieder erlauben
 		bank0	
 
		return

;******************************** DCF Routinen ************************************************

;**********************************************************************************************	
;** DCFROUTINE:							 			     **
;** 											     **
;** Das Unterprogramm DCFROUTINE ist fr die DCF-Dekodierung die wichtigste Komponente.	     **
;**											     **
;** Diese Routine wird ca. alle 4 ms aufgerufen						     **
;**									                     **
;** Aufgabe und Vorgehensweise: 							     **
;** 	Die Aufgabe des Unterprogrammes DCFROUTINE besteht darin aus den Abtastungen heraus- **
;**	zufinden, ob ein Low, ein High oder ein Minutenwechsel gesendet wurde. Dazu wird bei **
;**	jedem Aufruf des Unterprogramms DCFROUTINE entweder das Zaehlregister DCFPULS oder   **
;**	das Zaehlregister DCFPAUSE um 1 erhoeht (inkrementiert), wenn sich der Pegel vom DCF-**
;**	Eingang zum vorhergehenden Aufruf dieses Unterprogrammes nicht veraendert hat. Ist   **
;**	der DCF-Eingang Low (also logisch 0), so wird das Zaehlregister DCFPULS um 1 erhoeht,**
;**	ist der DCF-Eingang High (also logisch 1), so wird das Zaehlregister DCFPAUSE um 1   **
;**	erhoeht. Beide Zaehlregister koennen maximal den Wert 255 aufnehmen, was einer Zeit  **
;**	von 1020 ms (oder 1,02 Sekunden) entspricht (=255 * 4ms). 			     **
;** 	Unterscheidet sich der aktuelle Pegel des DCF-Eingangs mit dem Pegel vom vorher-     **
;**	gehenden Aufruf, so spricht man von einer Flanke, wobei hier zwischen einer fallenden**
;** 	und einer steigenden Flanke unterschieden werden muss. Bei einer fallenden Flanke    **
;**	(der aktuelle Pegel des DCF-Eingangs ist logisch 0), erfolgt zunaechst eine Aus-     **
;**	wertung des Zaehlregisters DCFPULS. Beinhaltet dieses Zaehlregister einen Wert       **
;**	zwischen den Konstanten KONSTDCFLMIN und KONSTDCFLMAX, so wurde ein LOW des DCF-     **
;**	Telegramms ermittelt. Im DCF-Statusregister (DCFSTATUS) werden daher die Flags DCFLOW**
;**	und DCFNEUESEK gesetzt. Das Flag DCFNEUESEK dient als Zeichen einer neu empfangenen  **
;**	und gueltigen Sekunde. Anschliessend wird das Zaehlregister DCFPULS geloescht.       **
;**	Beinhaltet das Zaehlregister DCFPULS einen Wert zwischen den Konstanten KONSTDCFHMIN **
;**	und KONSTDCFHMAX, so wurde ein HIGH des DCF-Telegramms ermittelt. Im DCF-Status-     **
;**	register (DCFSTATUS) werden daher die Flags DCFHIGH und DCFNEUESEK gesetzt. Das Flag **
;**	DCFNEUESEK dient auch hier als Zeichen einer neu empfangenen und gueltigen Sekunde,  **
;**	und auch das Zaehlregister DCFPULS wird anschliessend geloescht. Beinhaltet das      **
;**	Zaehlregister DCFPULS einen Wert der weder zwischen den Konstanten KONSTDCFLMIN und  **
;**	KONSTDCFLMAX noch zwischen den Konstanten KONSTDCFHMIN und KONSTDCFHIMAX liegt, so   **
;**	handelt es sich um einen Uebertragungsfehler. In diesem Fall wird das Fehlerflag     **
;**	(DCFFEHLER) im DCF-Statusregister (DCFSTATUS) gesetzt und auch das Zaehlregister     **
;**	DCFPULS wird anschlieend geloescht. Das Flag DCFNEUESEK wird hier aber nicht ge-    **
;**	setzt, da es sich in diesem Fall um keine gueltige Sekunde handelt. Das Fehlerflag   **
;**	wird erst bei der Erkennung einer neuen Minute wieder geloescht. Achtung: Solange    **
;**	das Fehlerflag gesetzt ist erfolgt keine Auswertung des Zaehlregisters DCFPULS.      **
;**	Dieses Zaehlregister wird aber dennoch bei jeder fallenden Flanke zurueckgesetzt.    **
;** 	Bei einer steigenden Flanke (der aktuelle Pegel des DCF-Eingangs ist logisch 1) wird **
;**	das Zaehlregister DCFPAUSE geloescht.						     ** 
;** 	In der 59. Sekunde erfolgt keine Absenkung des Traegers. Da es also in der 59.       **
;**	Sekunde keine fallende Flanke gibt, gibt es auch keine steigende Flanke. Das Zaehl-  **
;**	register DCFPAUSE laeuft ueber, da es nur einen Zaehlbereich von 0 bis 255 besitzt.  **
;**	Dieser Ueberlauf wird hier ausgenuetzt. Zur Bestimmung einer neuen Minute bzw. zur   **
;**	Bestimmung des Telegrammbeginns. Ist das Fehlerflag gesetzt, so wird es nun ge-      **
;**	loescht. War es nicht gesetzt, so wird das Flag DCFNEUEMIN im DCF-Statusregister     **
;**	(DCFSTATUS) gesetzt.	     							     **
;**											     **
;** Anmerkung:										     **
;** 	Die temporaeren Register TEMP1 und TEMP2 werden hier nur als Hilfsregister benoetigt.**
;** 	Sie koennen daher auch in anderen Unterprogrammen verwendet werden.		     **	
;**********************************************************************************************
DCFROUTINE	bcf	DCFSTATUS,DCFPORTALT	;DCFSTATUS,DCFPORTNEU -> DCFSTATUS,DCFPORTALT
		btfsc	DCFSTATUS,DCFPORTNEU
		bsf	DCFSTATUS,DCFPORTALT

		movf	DCFINPORT,w
		movwf	TEMP1
		bcf	DCFSTATUS,DCFPORTNEU	;DCFIN -> DCFSTATUS,DCFPORTNEU, TEMP1,DCFPORTALT
		btfsc	TEMP1,DCFIN
		bsf	DCFSTATUS,DCFPORTNEU
		clrf	TEMP2
		btfsc	TEMP1,DCFIN
		bsf	TEMP2,DCFPORTALT

		movf	DCFSTATUS,w
		xorwf	TEMP2,f

		btfss	TEMP2,DCFPORTALT	;Hat sich am Pin DCFIN der Pegel geaendert?
		goto	DCFINCPULSPAUSE		;nein: Puls- bzw. Pausezaehler um 1 erhoehen
		btfss	DCFSTATUS,DCFPORTNEU	;ja: -> steigende oder fallende Flanke?
		goto	DCFHLFLANKE		;fallende Flanke
DCFLHFLANKE	movlw	KONSTDCFNEUEMIN		;steigende Flanke: Zaehlregister DCFPAUSE  
		movwf	DCFPAUSE		;  mit der Konstante KONSTDCFNEUEMIN  
 		goto	DCFROUTINEFERTIG 	;  neu laden und UP verlassen			  		

		;Fallende Flanke
DCFHLFLANKE	btfss	DCFSTATUS,DCFFEHLER	;Fehlerflag gesetzt ? 	
		goto    DCFPLAUSIBEL		;nein: Ermittlung, ob die ermittelte Pulszeit
						;  einem HIGH oder einem LOW entspricht 
						;  (Plausibilitaetspruefung)  
 		goto	DCFPULSLOESCHEN		;ja: Puls-Zaehler loeschen
DCFPLAUSIBEL	
		;Pruefen, ob ein High empfangen wurde	
DCFCHECKHIGH	movlw	KONSTDCFHMIN		;unteren High-Grenzwert laden
		subwf	DCFPULS,w		
		btfss	STAT,C			;Grenzwert < DCFPULS ?
		goto	DCFCHECKLOW		;nein: kein HIGH-Pegel, pruefen, ob LOW
		movlw	KONSTDCFHMAX		;ja: DCFPULS mit oberen HIGH-Grenzwert
						;  vergleichen
		subwf	DCFPULS,w		;
		btfsc	STAT,C			;DCFPULS < Grenzwert ?	
		goto	DCFCHECKLOW		;nein: es handelt sich um kein HIGH-Signal
						;  pruefen, ob ein LOW empfangen wurde
		bcf	DCFSTATUS,DCFLOW	;ja: Es wurde ein High-Signal empfangen,
						;  das Flag DCFLOW loeschen, 
		bsf	DCFSTATUS,DCFHIGH	;  das Flag DCFHIGH setzen,
 		bsf	DCFSTATUS,DCFNEUESEK	;  das Flag DCFNEUESEK setzen
 		goto	DCFPULSLOESCHEN		;  und Puls-Zaehler loeschen

		;Pruefen, ob ein Low empfangen wurde	
DCFCHECKLOW	movlw	KONSTDCFLMIN		;unteren Low-Grenzwert laden
		subwf	DCFPULS,w		
		btfss	STAT,C			;Grenzwert < DCFPULS ?
		goto	DCFSETFEHLER		;nein: kein LOW-Pegel, Empfangsfehler
		movlw	KONSTDCFLMAX		;ja: DCFPULS mit oberen LOW-Grenzwert
						;  vergleichen
		subwf	DCFPULS,w		;
		btfsc	STAT,C			;DCFPULS < Grenzwert ?	
		goto	DCFSETFEHLER		;nein: es handelt sich um kein LOW-Signal
						;  -> Empfangsfehler
		bcf	DCFSTATUS,DCFHIGH	;ja: Es wurde ein LOW-Signal empfangen,
						;  das Flag DCFLOW setzen,  
		bsf	DCFSTATUS,DCFLOW	;  das Flag DCFHIGH loeschen,
		bsf	DCFSTATUS,DCFNEUESEK	;  das Flag DCFNEUESEK setzen
 		goto	DCFPULSLOESCHEN		;  und den Puls-Zaehler loeschen

		;Empfangsfehler
DCFSETFEHLER	bsf	DCFSTATUS,DCFFEHLER	;Bei einem Empfangsfehler 
		bcf	DCFSTATUS,DCFHIGH	;  Fehlerflag (DCFFEHLER) setzen,    
		bcf	DCFSTATUS,DCFLOW	;  die Flags DCFLOW und DCFHIGH loeschen,
 		goto	DCFPULSLOESCHEN		;  und den Puls-Zaehler loeschen

		;Pulszaehler erhoehen oder Pausenzaehler vermindern
DCFINCPULSPAUSE	btfsc	DCFSTATUS,DCFPORTNEU
		goto	DCFINCPAUSE

DCFINCPULS	incf	DCFPULS,f		;Puls-Zaehler um 1 erhoehen
		goto	DCFROUTINEFERTIG	

DCFINCPAUSE	decfsz	DCFPAUSE,f		;Pausezaehler um 1 vermindern 
				 		; und pruefen, ob DCFPAUSE = 0
	 
		goto	DCFROUTINEFERTIG	;nein: Unerprogramm verlassen

 		btfsc	DCFSTATUS,DCFFEHLER	;ja: NEUE MINUTE; wenn Fehlerflag
		goto	DCFROUTINEW1

		bsf	DCFSTATUS,DCFNEUEMIN	;nicht gesetzt, Flag DCFNEUEMIN setzen 
		goto	DCFROUTINEFERTIG	;  und Unterprogramm verlassen
	
DCFROUTINEW1	bcf	DCFSTATUS,DCFFEHLER	;Fehlerflag gesetzt: Fehlerflag loeschen
		goto 	DCFROUTINEFERTIG	;  und Unterprogramm verlassen (Flag DCFNEUEMIN
						;  wird in diesem Fall nicht gesetzt)

		;Pulszaehler loeschen						
DCFPULSLOESCHEN	clrf	DCFPULS		

DCFROUTINEFERTIG
		return


;**********************************************************************************************
;** Neue Sekunde:						 			     **
;** Aufgaben: 										     **
;**	+ je nachdem ob das Bit DCFLOW oder das Bit DCFHIGH gesetzt ist dieses Bit dem 	     **
;**	  Telegramm (Register DCFTELEGRAMM1 bis DCFTELEGRAMM8) hinzufuegen		     **
;**	+ Anforderungsflag (Flag DCFNEUESEK) zuruecksetzen				     **
;**											     **
;** Vorgehensweise:									     **
;**     Ist das Flag DCFLOW (im Register DCFSTATUS) gesetzt das Carryflag (im SFR STAT)      **
;**	loeschen, ist aber das Flag DCFHIGH (ebenfalls im Register DCFSTATUS) gesetzt das    **
;**	Carryflag setzten. Dieses Carryflag nun dem Telegramm hinzufuegen. Dieser Vorgang    **
;**     erfolgt mit einem sogenannten Schiebebefehl. Dabei werden alle Bits des Registers    **
;**     DCFTELEGRAMM1 auf die naechst hoehere Position verschoben. (Bit 6 wandert ins Bit 7, **
;**     Bit 5 wandert ins Bit 6 usw. Bit 0 wandert ins Bit 1). Der Inhalt vom Carryflag      **
;**     wandert ins Bit 0. Der Inhalt von Bit 7 wird ins Carryflag geschoben. Bei den        **
;**     Register DCFTELEGRAMM2 bis DCFTELEGRAMM6 erfolgt der selbe Vorgang. (Der Inhalt von  **
;**     Bit 7 des Registers DCFTELEGRAMM1 wird ins Carry geschoben, und das Carry aber weiter**
;**     in das Bit 0 des Registers DCFTELEGRAMM2)					     **
;**											     **
;** Anmerkung: 										     **
;**	Die Flags DCFLOW und DCFHIGH koennen nie gleichzeitig gesetzt sein. Es ist nur       **
;**	moeglich, dass entweder nur DCFLOW oder nur DCFHIGH gesetzt ist, aber nie beide      **
;**     gleichzeitig.									     **
;**********************************************************************************************
DCFUPSEKUNDE	btfsc	DCFSTATUS,DCFLOW  	;Ist das Flag DCFLOW im Register DCFSTATUS
						;  gesetzt?
		goto	DCFSCHIEBELOW
		btfsc	DCFSTATUS,DCFHIGH	;nein: Wenn das FLAG DCFHIGH im Register 
DCFSCHIEBEHIGH	bsf	STAT,C			;  DCFSTATUS gesetzt ist, Dem Telegramm ein
		goto	DCFSCHIEBE		;  Low mit Hilfe des Carry hinzufuegen
DCFSCHIEBELOW	bcf	STAT,C			;ja: Dem telegramm ein High mit Hilfe des Carry
						;  hinzufuegen
DCFSCHIEBE	rlf	DCFTELEGRAMM1,f	
		rlf	DCFTELEGRAMM2,f
		rlf	DCFTELEGRAMM3,f
		rlf	DCFTELEGRAMM4,f
		rlf	DCFTELEGRAMM5,f	
		rlf	DCFTELEGRAMM6,f
;		rlf	DCFTELEGRAMM7,f
;		rlf	DCFTELEGRAMM8,f
 
 		bcf	DCFSTATUS,DCFNEUESEK 	;Anforderungsflag loeschen
 		return


;**********************************************************************************************	
;** Neue Minute:						 			     **
;** Aufgaben: 										     **
;**	+ Fehlende 59. Sekunde "nachholen" (Unterprogramm DCFUPSEKUNDE aufrufen)	     **
;**	+ Datum, Uhrzeit und die Zusatzinformationen aus den Registern DCFTELEGRAMM1 bis     **
;**	  DCFTELEGRAMM8 zusammensetzen 							     **	
;**	+ Das soeben ermittelte Telegramm mit dem Telegramm der vorhergehenden Minute ver-   **
;**	  gleichen. Die soeben ermittelte Minute muss dabei um 1 groesser als die vorher-    **
;**	  gehende Minute sein, und die soeben ermittelten Werte fuer die Stunde, Tag, Monat, **
;**	  Jahr und Wochentag muss mit den Werten des vorhergehenden Telegramms ueberein-     **
;**	  stimmen. ACHTUNG: Bei dieser einfachen Ueberpruefung wird der Uebergang von z. B.  **
;**	  13:59 auf 14:00 als falsch gewertet, da sich hier die Stunde aendert, und auch die **
;**	  Minute um mehr als 1. Wuerden hier alle moeglichen Uebergaenge beruecksichtigt,    **
;**	  dann wuerde dieses Unterprogramm noch umfangreicher als es ohnehin schon ist. Durch**
;**	  diese Vereinfachung dauert die Syncronisierung im schlimmsten Fall nur eine Minute **
;**	  laenger.  									     **
;**     + Das alte Datum bzw. die alte Uhrzeit (von der vorhergehenden Minute) durch das neue**
;**       Datum bzw. Uhrzeit ersetzen. Dies ist fuer die Ueberpruefung des naechsten Tele-   **
;**	  gramms notwendig.								     **
;**     + Wenn das neu empfangene Datum bzw. die neu empfangene Uhrzeit gueltig ist, die BCD-**
;**	  kodierten Datums- bzw. Uhrzeitkomponenten in eine binaere Form umwandeln und damit **
;**       die mitlaufende Uhr syncronisieren. Das Flag DCFSYNC im Register DCFSTATUS setzen. **
;**	  Dieses gesetzte Flag kennzeichnet, dass die mitlaufende Uhr mit der DCF-Uhr        **
;**	  syncronisiert ist		 						     **  
;**	+ Anforderungsflag (Flag DCFNEUEMIN im Register DCFSTATUS) zuruecksetzen             **
;**											     **
;** Anmerkung:										     **
;** 	Das temporaere Register TEMP1 wird hier nur als Hilfsregister benoetigt, und kann    **
;** 	daher auch in anderen Unterprogrammen verwendet werden.		 		     **	
;**********************************************************************************************
DCFUPMINUTE	call 	DCFUPSEKUNDE		;Fehlende Sekunde nachholen

		clrf	DCFJAHRBCD		;Jahr zusammensetzen (BCD-Format)
		btfsc	DCFTELEGRAMM1,1
		bsf	DCFJAHRBCD,7
 		btfsc	DCFTELEGRAMM1,2
		bsf	DCFJAHRBCD,6
		btfsc	DCFTELEGRAMM1,3
		bsf	DCFJAHRBCD,5
		btfsc	DCFTELEGRAMM1,4
		bsf	DCFJAHRBCD,4
		btfsc	DCFTELEGRAMM1,5
		bsf	DCFJAHRBCD,3
		btfsc	DCFTELEGRAMM1,6
		bsf	DCFJAHRBCD,2
		btfsc	DCFTELEGRAMM1,7
		bsf	DCFJAHRBCD,1
		btfsc	DCFTELEGRAMM2,0
		bsf	DCFJAHRBCD,0

		clrf	DCFMONBCD		;Monat zusammensetzen (BCD-Format)
		btfsc	DCFTELEGRAMM2,1
		bsf	DCFMONBCD,4
 		btfsc	DCFTELEGRAMM2,2
		bsf	DCFMONBCD,3
		btfsc	DCFTELEGRAMM2,3
		bsf	DCFMONBCD,2
		btfsc	DCFTELEGRAMM2,4
		bsf	DCFMONBCD,1
		btfsc	DCFTELEGRAMM2,5
		bsf	DCFMONBCD,0
		 
		clrf	DCFWOCHENTAG		;Wochentag zusammensetzen (BCD-Format)
		btfsc	DCFTELEGRAMM2,6
		bsf	DCFWOCHENTAG,2
 		btfsc	DCFTELEGRAMM2,7
		bsf	DCFWOCHENTAG,1
		btfsc	DCFTELEGRAMM3,0
		bsf	DCFWOCHENTAG,0
		
		clrf	DCFTAGBCD		;Tag zusammensetzen (BCD-Format)
		btfsc	DCFTELEGRAMM3,1
		bsf	DCFTAGBCD,5
		btfsc	DCFTELEGRAMM3,2
		bsf	DCFTAGBCD,4
		btfsc	DCFTELEGRAMM3,3
		bsf	DCFTAGBCD,3
		btfsc	DCFTELEGRAMM3,4
		bsf	DCFTAGBCD,2
		btfsc	DCFTELEGRAMM3,5
		bsf	DCFTAGBCD,1
		btfsc	DCFTELEGRAMM3,6
		bsf	DCFTAGBCD,0

		clrf	DCFSTDBCD		;Stunde zusammensetzen (BCD-Format)
		btfsc	DCFTELEGRAMM4,0
		bsf	DCFSTDBCD,5		
		btfsc	DCFTELEGRAMM4,1
		bsf	DCFSTDBCD,4
		btfsc	DCFTELEGRAMM4,2
		bsf	DCFSTDBCD,3
		btfsc	DCFTELEGRAMM4,3
		bsf	DCFSTDBCD,2
		btfsc	DCFTELEGRAMM4,4
		bsf	DCFSTDBCD,1
		btfsc	DCFTELEGRAMM4,5
		bsf	DCFSTDBCD,0

		clrf	DCFMINBCD		;Minute zusammensetzen (BCD-Format)
		btfsc	DCFTELEGRAMM4,7
		bsf	DCFMINBCD,6		
		btfsc	DCFTELEGRAMM5,0
		bsf	DCFMINBCD,5
		btfsc	DCFTELEGRAMM5,1
		bsf	DCFMINBCD,4
		btfsc	DCFTELEGRAMM5,2
		bsf	DCFMINBCD,3
		btfsc	DCFTELEGRAMM5,3
		bsf	DCFMINBCD,2
		btfsc	DCFTELEGRAMM5,4
		bsf	DCFMINBCD,1
		btfsc	DCFTELEGRAMM5,5
		bsf	DCFMINBCD,0

;		clrf	DCFZUSATZINFOS		;Zusaetzliche Informationen
;		btfsc	DCFTELEGRAMM5,7		;  zusaetzliche Schaltsekunde
;		bsf	DCFZUSATZINFOS,DCFSCHALTSEK
;		btfsc	DCFTELEGRAMM6,0		;  Sommerzeit
;		bsf	DCFZUSATZINFOS,DCFSOMMER
;		btfsc	DCFTELEGRAMM6,1		;  Winterzeit
;		bsf	DCFZUSATZINFOS,DCFWINTER
;		btfsc	DCFTELEGRAMM6,2		;  Vorankuendigung: Wechsel  
;		bsf	DCFZUSATZINFOS,DCFSOMWIN ;   Sommerzeit <-> Winterzeit
;		btfsc	DCFTELEGRAMM6,3		;  Reserveantenne
;		bsf	DCFZUSATZINFOS,DCFRESANT  	
 	
		;Neues Telegramm mit dem alten Vergleichen
		bcf	DCFSTATUS,DCFFEHLER	;zuerst Fehlerflag loeschen

 		movf	DCFMINALT,w		;Minuten pruefen
		subwf	DCFMINBCD,w
		movwf	TEMP1			;TEMP1 = DCFMINBCD - DCFMINALT
		decfsz	TEMP1,w			;TEMP1 - 1 = 0 ?
		bsf	DCFSTATUS,DCFFEHLER	;nein: Fehlerflag setzen 

		movf	DCFSTDALT,w		;Stunden pruefen
		subwf	DCFSTDBCD,w
		btfss	STAT,Z			;DCFSTDBCD - DCFSTDALT = 0?  	
		bsf	DCFSTATUS,DCFFEHLER	;nein: Fehlerflag setzen

		movf	DCFTAGALT,w		;Tag pruefen
		subwf	DCFTAGBCD,w
		btfss	STAT,Z			;DCFTAGBCD - DCFTAGBCD = 0?		 	
		bsf	DCFSTATUS,DCFFEHLER	;nein: Fehlerflag setzen
				
		movf	DCFMONALT,w		;Monat pruefen
		subwf	DCFMONBCD,w
		btfss	STAT,Z			;DCFMONBCD - DCFMONALT = 0?	
		bsf	DCFSTATUS,DCFFEHLER	;nein: Fehlerflag setzen
				
		movf	DCFJAHRALT,w		;Jahr pruefen
		subwf	DCFJAHRBCD,w
		btfss	STAT,Z			;DCFJAHRBCD - DCFJAHRALT = 0?	
		bsf	DCFSTATUS,DCFFEHLER	;nein: Fehlerflag setzen
				
		movf	DCFWTAGALT,w		;Wochentag pruefen
		subwf	DCFWOCHENTAG,w
		btfss	STAT,Z			;DCFWOCHENTAG - DCFWTAGALT = 0?	
		bsf	DCFSTATUS,DCFFEHLER	;nein: Fehlerflag setzen

		;Altes Telegramm durch das neue Telegramm ersetzen
		movf	DCFMINBCD,w
		movwf	DCFMINALT

		movf	DCFSTDBCD,w
		movwf	DCFSTDALT

		movf	DCFTAGBCD,w
		movwf	DCFTAGALT

		movf	DCFMONBCD,w
		movwf	DCFMONALT

		movf	DCFJAHRBCD,w
		movwf	DCFJAHRALT

		movf	DCFWOCHENTAG,w
		movwf	DCFWTAGALT	

		btfsc	DCFSTATUS,DCFFEHLER	;DCF-Telegramm korrekt?
		goto	DCFUPMINUTEENDE		;nein: UP beenden
		movf	DCFSTDBCD,w 		;ja: DCFSTDBCD  
		call	BCDBIN2			;von BCD nach binaer umwandeln
		movwf	UHRSTUNDE		;und die Stunde der mitlaufenden Uhr 
						;ueberschreiben

		movf	DCFMINBCD,w		;DCFMINBCD
		call	BCDBIN2			;von BCD nach binaer umwandeln
		movwf	UHRMINUTE		;und die Minute der mitlaufenden Uhr
						;ueberschreiben

		clrf	UHRSEKUNDE		;Sekunde loeschen

		bsf	DCFSTATUS,DCFSYNC	 

DCFUPMINUTEENDE	bcf	DCFSTATUS,DCFFEHLER
		bcf	DCFSTATUS,DCFNEUEMIN 	;Anforderungsflag loeschen

		return


;******************************** Drehimpulsgeber (Inkrementalgeber) - Routine ****************

;**********************************************************************************************
;** INKRROUTINE										     **
;** Diese Routine wird ca. alle 4 ms aufgerufen	     					     **
;**											     **
;** Aufgabe: Ermittelt ob und in welche Richtung der Drehimpulsgeber (= Inkrementalgeber)    **
;** 	gedreht wurde. Das Ergebnis befindet sich dann im Register INKRSTATUS. Dieses 	     **
;**	Register besitzt die folgenden Bits (Flags):		    			     **
;** 	  + INKR1ALT, INKR2ALT: Beinhalten den Zustand des Drehimpulsgeber fuer den naechsten**
;**				Aufruf dieses Unterprogramms.				     **
;**	  + INKRLINKS:		Wird von diesem Unterprogramm gesetzt, wenn eine Drehung nach**
;**				links des Drehimpulsgebers dekodiert wurde.		     ** 
;**	  + INKRRECHTS:		Wird von diesem Unterprogramm gesetzt, wenn eine Drehung nach**
;**				rechts des Drehimpulsgebers dekodiert wurde.		     **   	 
;**											     **
;** Allgemeines: Der Inkrementalgeber ist (so wie auch bei Tasten) am Port D mit zwei Pull-  **
;**     Up-Widerstand angeschlossen. 							     **
;**     Die Eingaenge des Drehimpulsgebers muessen hier am selben Port angeschlossen sein,   **
;**	welche Bits verwendet werden ist jedoch beliebig und muessen nicht "nebeneinander"   **
;**	liegen. (Eingang A kann z.B. am Port RD0 liegen, waehrend der Eingang B dem Portpin  **
;**	RD5 zugeordnet ist) 								     **
;**											     **
;** Vorgehensweise: 									     **
;**	+ Port D einlesen und im Register TEMP1 sichern.				     **					     
;**	+ Sind die beiden Bits des "alten" Zustandes ungleich, zum Ende des Unterprogramms   **
;**       springen. (Das Register TEMP2 dient zur Ueberpruefung, ob die Bits gleich (bzw. un-**
;**	  gleich) sind 									     **
;**     + Sind die beiden Bits des "alten" Zustandes gleich, testen, ob die beiden Bits des  **
;**       "neuen" Zustands ungleich sind. (Auch hier dient das Register TEMP2 zur Ueber-     **
;**	  pruefung, ob die Bits gleich (bzw. ungleich) sind				     **
;**     + Sind die beiden Bedingungen erfuellt (Bits des alten Zustands gleich und Bits des  **
;**	  neuen Zustands ungleich) so wurde der Drehimpulsgeber verdreht. Als naechstes gilt **
;**	  es herauszufinden in welche Richtung der Drehimpulsgeber gedreht wurde. Dazu den   **
;**       alten Zustand (Register INKRSTATUS) mit dem neuen Zustand (TEMP1) exklusiv-Oder-   **
;**	  verknuepfen. Je nachdem welches der beiden Bits nun gesetzt ist erfolgte entweder  **
;**	  eine Drehung nach links oder eine Drehung nach rechts (Anmerkung: Beide Bits	     **
;**	  koennen nicht gesetzt sein. Dies wurde ja im vorgehenden Schritt ueberprueft!)     **
;**     + Vom Register TEMP1 nur die Eingaenge an denen der Drehimpulsgeber angeschlossen ist**
;**	  ausmaskieren und in das Register INKRSTATUS kopieren und je nach ermittelter Dreh- **
;**	  richtung das Flag INKRLINKS oder INKRRECHTS setzen.				     **
;**											     **
;** Anmerkung: Die temporaeren Register TEMP1 und TEMP2 werden hier nur zum Zwischenspeichern**
;**	(TEMP1) bzw. als Hilfsregister (TEMP2) benoetigt. Sie koennen daher auch woanders    **
;**	verwendet werden.  								     **
;********************************************************************************************** 
INKRROUTINE	movf	PORTD,w			;PORT A in das Hilfsregister TEMP1 kopieren
		movwf	TEMP1

		;Testen ob die beiden Bits des "alten" Zustands gleich sind
		clrf	TEMP2
		btfsc	INKRSTATUS,INKR2ALT
		bsf	TEMP2,INKR1ALT

		movf	INKRSTATUS,w
		xorwf	TEMP2,f

 		btfsc	TEMP2,INKR1ALT
		goto	UPINKRWEITER 		;INKR1 ist ungleich zu INKR2 -> folgende
						;  Befehle ueberspringen
		
		;Testen, ob die beiden Bits des "neuen" Zustands ungleich sind
		clrf	TEMP2
		btfsc	TEMP1,INKR2 
		bsf	TEMP2,INKR1 

		movf	TEMP1,w
		xorwf	TEMP2,f
		btfss	TEMP2,INKR1 		
		goto	UPINKRWEITER 		;INKR1 ist gleich zu INKR2 -> folgende
						;  Befehle ueberspringen

		;Ermittlung in welche Richtung gedreht wurde
		movf	TEMP1,w			;TEMP1 und INKRSTATUS
		xorwf	INKRSTATUS,f		;  exklusiv-Oder verknuepfen 
		btfss	INKRSTATUS,INKR1 	
		goto	UPINKRRE 
		 		
UPINKRLI 	movf	TEMP1,w			;Bei einer ermittelten Linksdrehung die
		andlw	MASKEINKR		;  Eingaenge an denen der Drehimpulsgeber 
		movwf	INKRSTATUS		;  angeschlossen ist ausmaskieren und in das
						;  Register INKRSTATUS kopieren
		bsf	INKRSTATUS,INKRLINKS	;  Flag INKRLINKS setzen
		goto	UPINKRENDE

UPINKRRE 	movf	TEMP1,w			;Bei einer ermittelten Rechtsdrehung die
		andlw	MASKEINKR		;  Eingaenge an denen der Drehimpulsgeber 
		movwf	INKRSTATUS		;  angeschlossen ist ausmaskieren und in das
						;  Register INKRSTATUS kopieren
		bsf	INKRSTATUS,INKRRECHTS	;  Flag INKRRECHTS setzen
		goto	UPINKRENDE

		;Bei Nichterfuellung der ersten beiden Bedingungen (Bits des alten Zustands 
		;gleich und Bits des neuen Zustands ungleich)
UPINKRWEITER 	movf	TEMP1,w			;Eingaenge an denen der Drehimpulsgeber
		andlw	MASKEINKR		;  angeschlossen ist ausmaskieren und in das
		movwf	INKRSTATUS		;  Register INKRSTATUS kopieren

UPINKRENDE	return


;**********************************************************************************************
;** INKRLINKSDREHUNG									     **
;** Diese Routine wird nach einer Drehung nach links des Inkrementalgebers aufgerufen	     **
;**********************************************************************************************
INKRLINKSDREHUNG
		btfss	ESUTASTENE,INKR1
		goto	UPINKRLINKSENDE

		btfsc	ESUSTATUS,3		;Sanduhr im Mode STAND-BY?
		call	STANDBYAUS		;ja: Stand-By-Mode beenden und 

		bcf	ESUZEITSTATUS,0		;Gesamtzeit anzeigen 
		bcf	ESUZEITSTATUS,1
		bcf	ESUZEITSTATUS,2
		bsf	ESUZEITSTATUS,4

		btfsc	PORTD,TASTEPAUSE
		goto	INKRLINKSVERMMIN

INKRLINKSVERMSEK				;Sekunde um 1 vermindern
		movf	ESUZEITGESSEK,f
		btfsc	STAT,Z
		goto	INKRLINKSVERMSEKW1
		decf	ESUZEITGESSEK,f
		goto	UPINKRLINKSENDE

INKRLINKSVERMSEKW1
		movlw	.59	
		movwf	ESUZEITGESSEK

		movf	ESUZEITGESMIN,f
		btfsc	STAT,Z
		goto	INKRLINKSVERMSEKW2
		decf	ESUZEITGESMIN,f
		goto	UPINKRLINKSENDE

INKRLINKSVERMSEKW2
		movlw	.99
		movwf	ESUZEITGESMIN
		goto	UPINKRLINKSENDE

INKRLINKSVERMMIN				;Minute um 1 vermindern
		movf	ESUZEITGESMIN,f
		btfsc	STAT,Z
		goto	INKRLINKSVERMMINW1
		decf	ESUZEITGESMIN,f
		goto	UPINKRLINKSENDE

INKRLINKSVERMMINW1
		movlw	.99	
		movwf	ESUZEITGESMIN

UPINKRLINKSENDE	return


;**********************************************************************************************
;** INKRRECHTSDREHUNG									     **
;** Diese Routine wird nach einer Drehung nach rechts des Inkrementalgebers aufgerufen	     **
;**********************************************************************************************
INKRRECHTSDREHUNG
		btfss	ESUTASTENE,INKR1
		goto	UPINKRRECHTSENDE

		btfsc	ESUSTATUS,3		;Sanduhr im Mode STAND-BY?
		call	STANDBYAUS		;ja: Stand-By-Mode beenden und 
		 
		bcf	ESUZEITSTATUS,0		;nein: Gesamtzeit anzeigen 
		bcf	ESUZEITSTATUS,1
		bcf	ESUZEITSTATUS,2
		bsf	ESUZEITSTATUS,4

		btfsc	PORTD,TASTEPAUSE
		goto	INKRRECHTSERHMIN

INKRRECHTSERHSEK				;Sekunde um 1 erhoehen
		incf	ESUZEITGESSEK,f
		movf	ESUZEITGESSEK,w
		sublw	.60
		btfss	STAT,Z
		goto	UPINKRLINKSENDE
		clrf	ESUZEITGESSEK
		incf	ESUZEITGESMIN,f
		movf	ESUZEITGESMIN,w
		sublw	.100
		btfsc	STAT,Z
		clrf	ESUZEITGESMIN
		goto	UPINKRLINKSENDE
		
INKRRECHTSERHMIN				;Minute um 1 erhoehen
		incf	ESUZEITGESMIN,f
		movf	ESUZEITGESMIN,w
		sublw	.100
		btfsc	STAT,Z
		clrf	ESUZEITGESMIN
		goto	UPINKRLINKSENDE
		 
UPINKRRECHTSENDE		
		return


;******************************** Sanduhrspezifische Unterprogramme ***************************

;**********************************************************************************************
;** ZUSTAND0										     **
;** Aufgabe:										     **
;**     Ausgangszustand der LEDs (die unteren 51 LEDs leuchten, diese daher in die Register  **
;**     POS1 bis POS51 laden)								     **
;**  										       	     **
;** ACHTUNG: 										     **
;**     Diese Register befinden sich in der Registerbank 1, es muss daher zunaechst mit Hilfe**
;**     des Makros "bank1" in die Registerbank 1 umgeschaltet werden. Bevor dieses Unter-    **
;**     programm verlassen wird, muss wieder zur Registerbank 0 zurueckgekehrt werden (Mit   **
;**     Hilfe des Makros "bank0".							     **
;**********************************************************************************************		
ZUSTAND0	bank1	

		movlw	LED52	
		movwf	ESULEDPOS1
		movlw	LED53
		movwf	ESULEDPOS2
		movlw	LED54
		movwf	ESULEDPOS3
		movlw	LED55
		movwf	ESULEDPOS4
		movlw	LED56
		movwf	ESULEDPOS5
		movlw	LED57
		movwf	ESULEDPOS6
		movlw	LED58
		movwf	ESULEDPOS7
		movlw	LED59
		movwf	ESULEDPOS8
		movlw	LED60
		movwf	ESULEDPOS9
		movlw	LED61
		movwf	ESULEDPOS10
		movlw	LED62
		movwf	ESULEDPOS11
		movlw	LED63
		movwf	ESULEDPOS12
		movlw	LED64
		movwf	ESULEDPOS13
		movlw	LED65
		movwf	ESULEDPOS14
		movlw	LED66
		movwf	ESULEDPOS15
		movlw	LED67
		movwf	ESULEDPOS16
		movlw	LED68
		movwf	ESULEDPOS17
		movlw	LED69
		movwf	ESULEDPOS18
		movlw	LED70
		movwf	ESULEDPOS19
		movlw	LED71
		movwf	ESULEDPOS20
		movlw	LED72
		movwf	ESULEDPOS21
		movlw	LED73
		movwf	ESULEDPOS22
		movlw	LED74
		movwf	ESULEDPOS23
		movlw	LED75
		movwf	ESULEDPOS24
		movlw	LED76
		movwf	ESULEDPOS25
		movlw	LED77
		movwf	ESULEDPOS26
		movlw	LED78
		movwf	ESULEDPOS27
		movlw	LED79
		movwf	ESULEDPOS28
		movlw	LED80
		movwf	ESULEDPOS29
		movlw	LED81
		movwf	ESULEDPOS30
		movlw	LED82
		movwf	ESULEDPOS31
		movlw	LED83
		movwf	ESULEDPOS32
		movlw	LED84
		movwf	ESULEDPOS33
		movlw	LED85
		movwf	ESULEDPOS34
		movlw	LED86
		movwf	ESULEDPOS35
		movlw	LED87
		movwf	ESULEDPOS36
		movlw	LED88
		movwf	ESULEDPOS37
		movlw	LED89
		movwf	ESULEDPOS38
		movlw	LED90
		movwf	ESULEDPOS39
		movlw	LED91
		movwf	ESULEDPOS40
		movlw	LED92
		movwf	ESULEDPOS41
		movlw	LED93
		movwf	ESULEDPOS42
		movlw	LED94
		movwf	ESULEDPOS43
		movlw	LED95
		movwf	ESULEDPOS44
		movlw	LED96
		movwf	ESULEDPOS45
		movlw	LED97
		movwf	ESULEDPOS46
		movlw	LED98
		movwf	ESULEDPOS47
		movlw	LED99
		movwf	ESULEDPOS48
		movlw	LED100
		movwf	ESULEDPOS49
		movlw	LED101
		movwf	ESULEDPOS50
		movlw	LED51
		movwf	ESULEDPOS51
 
		bank0
		return


;**********************************************************************************************
;** ZUSTAND1										     **
;** Aufgabe:										     **
;**     Zustand nach drcken der Starttaste. Die oberen 51 LEDs leuchten, diese daher in die **
;**  	Register POS1 bis POS51 laden. 							     **
;**											     **
;** ACHTUNG: 										     **
;**     Diese Register befinden sich in der Registerbank 1, es muss daher zunaechst mit Hilfe**
;**     des Makros "bank1" in die Registerbank 1 umgeschaltet werden. Bevor dieses Unter-    **
;**     programm verlassen wird, muss wieder zur Registerbank 0 zurueckgekehrt werden (Mit   **
;**     Hilfe des Makros "bank0".							     **
;**********************************************************************************************		
ZUSTAND1	bank1

		movlw	LED1
		movwf	ESULEDPOS1
		movlw	LED2
		movwf	ESULEDPOS2
		movlw	LED3
		movwf	ESULEDPOS3
		movlw	LED4
		movwf	ESULEDPOS4
		movlw	LED5
		movwf	ESULEDPOS5
		movlw	LED6
		movwf	ESULEDPOS6
		movlw	LED7
		movwf	ESULEDPOS7
		movlw	LED8
		movwf	ESULEDPOS8
		movlw	LED9
		movwf	ESULEDPOS9
		movlw	LED10
		movwf	ESULEDPOS10
		movlw	LED11
		movwf	ESULEDPOS11
		movlw	LED12
		movwf	ESULEDPOS12
		movlw	LED13
		movwf	ESULEDPOS13
		movlw	LED14
		movwf	ESULEDPOS14
		movlw	LED15
		movwf	ESULEDPOS15
		movlw	LED16
		movwf	ESULEDPOS16
		movlw	LED17
		movwf	ESULEDPOS17
		movlw	LED18
		movwf	ESULEDPOS18
		movlw	LED19
		movwf	ESULEDPOS19
		movlw	LED20
		movwf	ESULEDPOS20
		movlw	LED21
		movwf	ESULEDPOS21
		movlw	LED22
		movwf	ESULEDPOS22
		movlw	LED23
		movwf	ESULEDPOS23
		movlw	LED24
		movwf	ESULEDPOS24
		movlw	LED25
		movwf	ESULEDPOS25
		movlw	LED26
		movwf	ESULEDPOS26
		movlw	LED27
		movwf	ESULEDPOS27
		movlw	LED28
		movwf	ESULEDPOS28
		movlw	LED29
		movwf	ESULEDPOS29
		movlw	LED30
		movwf	ESULEDPOS30
		movlw	LED31
		movwf	ESULEDPOS31
		movlw	LED32
		movwf	ESULEDPOS32
		movlw	LED33
		movwf	ESULEDPOS33
		movlw	LED34
		movwf	ESULEDPOS34
		movlw	LED35
		movwf	ESULEDPOS35
		movlw	LED36
		movwf	ESULEDPOS36
		movlw	LED37
		movwf	ESULEDPOS37
		movlw	LED38
		movwf	ESULEDPOS38
		movlw	LED39
		movwf	ESULEDPOS39
		movlw	LED40
		movwf	ESULEDPOS40
		movlw	LED41
		movwf	ESULEDPOS41
		movlw	LED42
		movwf	ESULEDPOS42
		movlw	LED43
		movwf	ESULEDPOS43
		movlw	LED44
		movwf	ESULEDPOS44
		movlw	LED45
		movwf	ESULEDPOS45
		movlw	LED46
		movwf	ESULEDPOS46
		movlw	LED47
		movwf	ESULEDPOS47
		movlw	LED48
		movwf	ESULEDPOS48
		movlw	LED49
		movwf	ESULEDPOS49
		movlw	LED50
		movwf	ESULEDPOS50
		movlw	LED51
		movwf	ESULEDPOS51
 
		bank0
		return


;**********************************************************************************************
;** LEDANZEIGE  									     **
;** Aufgabe: 										     **
;**	Bei jedem Aufruf dieses Unterprogrammes die naechste LED der LED-Matrix am Port B    **
;**	ausgeben. In den Registern ESULEDPOS1 bis ESULEDPOS51 befinden sich die Adressen der **
;**     51 aktiven (= zur Zeit leuchtenden Leuchtdioden). Beim ersten Aufruf dieses Unter-   **
;**     programmes wird die der Registerinhalt von ESULEDPOS1 ausgelesen und am PORT B ausge-**
;**     geben. Beim zweiten Aufruf dieses Unterprogrammes wird der Registerinhalt von        **
;**     ESULEDPOS2 ausgelesen und am Port B ausgegeben usw. Beim 52ten Aufruf wird wieder    **
;**     aus dem Register ESULEDPOS1 ausgelesen und am Port B ausgegeben. 		     **
;**	Zum Auslesen des Registerinhaltes wird die indirekte Adressierung benutzt, wobei das **
;**     Register ESULEDZAEHL gibt an, welches Register ausgelesen wird. Dieses Register wird **
;**     zunaechst um 1 vermindert. Beinhaltet es dann den Wert 0, so wird dieses Register    **
;**     mit dem Wert 51 (= Konstante LEDANZAKTIV) neu geladen. Bei der indirekten            **
;**     Adressierung wird die Adresse des auszulesenden Registers verwendet. Der Registername**
;**     ist hier nicht von Bedeutung. Das Register ESULEDPOS1 besitzt, da es sich in der     **
;**     Registerbank 1 befindet die Adresse A0h. Das Register ESULEDPOS2 die Adresse A1h     **
;**     usw., das Register ESULEDPOS51 besitzt demnach die Adresse D2h. Zum Inhalt von       **
;**     Register ESULEDZAEHL muss also eine Wert addiert werden. Das Ergebnis gibt dann die  **
;**     Adresse der mittels indirekter Adressierung auszulesenden Registers an. Wird das     **
;**     Register FSR mit diesem Ergebnis geladen, so befindet sich dann im Register IND der  **
;**     Registerinhalt des durch die indirekte Adressierung bestimmten Registers. Die        **
;**     Register FSR und IND sind Register, welche bereits im Controller implementiert sind. **
;**											     **
;** Vorgehensweise:									     **
;**	+ Register ESULEDZAEHL um 1 vermindern. Beinhaltet dieses Register dadurch den Wert  **
;**	  0, dieses Register mit der Konstante LEDANZAKTIV (=51) laden			     **
;**	+ Zum Register ESULEDZAEHL den Hexadezimalwert 9F addieren. Das Ergerbnis wird im    **
;**	  Arbeitsregister (w-Register) abgelegt.					     **
;**     + Das FSR mit dem Arbeitsregister laden. Das Register IND beinhaltet nun den 	     **
;**	  Registerinhalt des Registers welches der Registeradresse aus der Summe von 9F und  **
;**	  ESULEDZAEHL entspricht  							     **
;**	+ Registerinhalt von IND am Port B ausgeben					     **
;**     + Unterprogramm verlassen							     **
;**********************************************************************************************		
LEDANZEIGE	decfsz	ESULEDZAEHL,f		;Zaehlvar. um 1 erniedrigen
		goto	UPLEDWEITER1
		movlw	LEDANZAKTIV		;wenn ESULEDZAEHL=0, ESULEDZAEHL wieder mit der 
		movwf	ESULEDZAEHL		;Konstante LEDANZAKTIV (=51) laden
UPLEDWEITER1	movlw	9F			;Indirekte Adresse bestimmen: 
		addwf	ESULEDZAEHL,w		;  (= ESULEDZAEHL + 1Fh + 80h)
		movwf	FSR
		movf	IND,w			;akt. LED-Adresse aus RAM laden
		movwf	PORTB			;und am Port ausgeben
	 	return


;**********************************************************************************************
;** ZEITANZEIGE 									     **
;**											     **
;**  										       	     **
;**											     **
;** Anmerkung: Die temporaeren Register TEMP1 und TEMP2 werden hier nur zum Zwischenspeichern**
;**	benoetigt. Sie koennen daher auch woanders verwendet werden.			     **
;**********************************************************************************************		
ZEITANZEIGE	movlw	b'111'			;Auf den nicht verwendeten Ausgang Q7 des 
		movwf	PORTE			;  (3-aus-8-Dekoders schalten)

		movf	ESUZEITAKTSPALTE,w	;TEMP1 = ANZZEILE + 1
		movwf	TEMP1
		incf	TEMP1,f		

		movf	ESUZEITSTATUS,w
		movwf	TEMP2			;TEMP2 = ESUZEITSTATUS		
	
UPZEITSCHL1	decfsz	TEMP1,f
		goto	UPZEITSCHL2
		goto	UPZEITWEITER1

UPZEITSCHL2	rrf	TEMP2,f
		goto	UPZEITSCHL1	

UPZEITWEITER1	btfss	STAT,C
		goto	UPZEITWEITER2
		bcf	PORTA,ZEIT_DATA
		goto	UPZEITWEITER3
UPZEITWEITER2	bsf	PORTA,ZEIT_DATA
UPZEITWEITER3	bsf	PORTA,ZEIT_CLK	 	;Takt fuer
		bcf	PORTA,ZEIT_CLK		;  Schieberegister (IC3 und IC4)

		movlw	.5
		movwf	TEMP1

		movlw	0xD2
		addwf	ESUZEITAKTSPALTE,w
		movwf	FSR
		movf	IND,w
		movwf	TEMP2

UPZEITSCHL3	btfsc	TEMP2,0
		goto	UPZEITWEITER4
		bcf	PORTA,ZEIT_DATA
		goto	UPZEITWEITER5
UPZEITWEITER4	bsf	PORTA,ZEIT_DATA
UPZEITWEITER5	bsf	PORTA,ZEIT_CLK
		bcf	PORTA,ZEIT_CLK

		rrf	TEMP2,f

		decfsz	TEMP1,f
		goto	UPZEITSCHL3

		movlw	.5
		movwf	TEMP1

		movlw	0xD8
		addwf	ESUZEITAKTSPALTE,w
		movwf	FSR
		movf	IND,w
		movwf	TEMP2


UPZEITSCHL4	btfsc	TEMP2,0
		goto	UPZEITWEITER6
		bcf	PORTA,ZEIT_DATA
		goto	UPZEITWEITER7
UPZEITWEITER6	bsf	PORTA,ZEIT_DATA
UPZEITWEITER7	bsf	PORTA,ZEIT_CLK
		bcf	PORTA,ZEIT_CLK

		rrf	TEMP2,f

		decfsz	TEMP1,f
		goto	UPZEITSCHL4

		decf	ESUZEITAKTSPALTE,w
		movwf	PORTE

		decfsz	ESUZEITAKTSPALTE,f
		goto	UPZEITENDE
		movlw	.6
		movwf	ESUZEITAKTSPALTE

UPZEITENDE	return


;**********************************************************************************************
;** ZEITAUSWAHL 									     **
;**											     **
;**  										       	     **
;**											     **
;** Anmerkung: Die temporaeren Register TEMP1 bis TEMP5 werden hier nur zum Zwischenspeichern**
;**	benoetigt. Sie koennen daher auch woanders verwendet werden.			     **
;**********************************************************************************************		
ZEITAUSWAHL
 
		btfsc	ESUZEITSTATUS,0
		goto	UPZEITWEITER8
		btfsc	ESUZEITSTATUS,1
		goto	UPZEITWEITER9
		btfsc	ESUZEITSTATUS,2
		goto	UPZEITWEITER10
		goto	UPZEITWEITER11

UPZEITWEITER8	
		btfss	DCFSTATUS,DCFSYNC
		goto	UPZEITWEITER8A

		movf	UHRSTUNDE,w
		movwf	TEMP5
		movf	UHRMINUTE,w
		movwf	TEMP4
		goto	UPZEITWEITER13
 
UPZEITWEITER8A	bank1
		movlw	.27
		movwf	ESUZEITANZ11
		movwf	ESUZEITANZ12
		movwf	ESUZEITANZ13
		movwf	ESUZEITANZ21
		movwf	ESUZEITANZ22
		movwf	ESUZEITANZ23
		movwf	ESUZEITANZ31
		movwf	ESUZEITANZ32
		movwf	ESUZEITANZ33
		movwf	ESUZEITANZ41
		movwf	ESUZEITANZ42
		movwf	ESUZEITANZ43
		bank0
		goto	UPZEITENDE2

UPZEITWEITER9	movf	ESUZEITABMIN,w
		movwf	TEMP5
		movf	ESUZEITABSEK,w
		movwf	TEMP4
		goto	UPZEITWEITER13

UPZEITWEITER10	movf	ESUZEITBLEIBMIN,w
		movwf	TEMP5
		movf	ESUZEITBLEIBSEK,w
		movwf	TEMP4
		goto	UPZEITWEITER13			 

UPZEITWEITER11	movf	ESUZEITGESMIN,w
		movwf	TEMP5
		movf	ESUZEITGESSEK,w
		movwf	TEMP4
		goto	UPZEITWEITER13

UPZEITWEITER13	movf	TEMP4,w		
		call	BINBCD2
		movwf	TEMP4		
		
		movf	TEMP5,w
		call	BINBCD2
		movwf	TEMP2
		movwf	TEMP1

		movf	TEMP4,w
		movwf	TEMP3
		swapf	TEMP3,f
			
		swapf	TEMP1,f
		movlw	b'00001111'
		andwf	TEMP1,f
		andwf	TEMP2,f		
		andwf	TEMP3,f
		andwf	TEMP4,f	

		movlw	.4
		movwf	TEMP5

		clrw
UPZEITSCHL5	decfsz	TEMP5,f
		goto	UPZEITWEITER14
		goto	UPZEITWEITER15

UPZEITWEITER14	addwf	TEMP1,w
		goto	UPZEITSCHL5	

UPZEITWEITER15	addlw	.1
		movwf	TEMP1

 		call	TABZIFFERN
		bank1
		movwf	ESUZEITANZ11
		bank0

		incf	TEMP1,f
		movf	TEMP1,w

 		call	TABZIFFERN
		bank1
		movwf	ESUZEITANZ12
		bank0				

		incf	TEMP1,f
		movf	TEMP1,w

 		call	TABZIFFERN
		bank1
		movwf	ESUZEITANZ13
		bank0	

		movlw	.4
		movwf	TEMP5

		clrw
UPZEITSCHL6	decfsz	TEMP5,f
		goto	UPZEITWEITER16
		goto	UPZEITWEITER17

UPZEITWEITER16	addwf	TEMP2,w
		goto	UPZEITSCHL6	

UPZEITWEITER17	addlw	.1
		movwf	TEMP2

 		call	TABZIFFERN
		bank1
		movwf	ESUZEITANZ21
		bank0

		incf	TEMP2,f
		movf	TEMP2,w

 		call	TABZIFFERN
		bank1
		movwf	ESUZEITANZ22
		bank0				

		incf	TEMP2,f
		movf	TEMP2,w

 		call	TABZIFFERN
		bank1
		movwf	ESUZEITANZ23
		bank0	

		movlw	.4
		movwf	TEMP5

		clrw
UPZEITSCHL7	decfsz	TEMP5,f
		goto	UPZEITWEITER18
		goto	UPZEITWEITER19

UPZEITWEITER18	addwf	TEMP3,w
		goto	UPZEITSCHL7	

UPZEITWEITER19	addlw	.1
		movwf	TEMP3

 		call	TABZIFFERN
		bank1
		movwf	ESUZEITANZ31
		bank0

		incf	TEMP3,f
		movf	TEMP3,w

 		call	TABZIFFERN
		bank1
		movwf	ESUZEITANZ32
		bank0				

		incf	TEMP3,f
		movf	TEMP3,w

 		call	TABZIFFERN
		bank1
		movwf	ESUZEITANZ33
		bank0	

 		movlw	.4
		movwf	TEMP5

		clrw
UPZEITSCHL8	decfsz	TEMP5,f
		goto	UPZEITWEITER20
		goto	UPZEITWEITER21

UPZEITWEITER20	addwf	TEMP4,w
		goto	UPZEITSCHL8	

UPZEITWEITER21	addlw	.1
		movwf	TEMP4

 		call	TABZIFFERN
		bank1
		movwf	ESUZEITANZ41
		bank0

		incf	TEMP4,f
		movf	TEMP4,w

 		call	TABZIFFERN
		bank1
		movwf	ESUZEITANZ42
		bank0				

		incf	TEMP4,f
		movf	TEMP4,w

 		call	TABZIFFERN
		bank1
		movwf	ESUZEITANZ43
		bank0	

UPZEITENDE2	return


;**********************************************************************************************
;** LAUTSPRECHER									     **
;**											     **
;** Aufgabe: Solange das Fertig-Flag im Sanduhr-Statusregister gesetzt ist, den Portpin RC0  **
;** bei jedem Aufruf dieses Unterprogrammes toggeln. Diese Unterprogramm wird ca. alle 250us **
;** aufgerufen. Diese ergibt somit einen Ton mit ca. 1kHz.			       	     **
;**********************************************************************************************		
LAUTSPRECHER
		;Dauerton	
		btg	ESUHILFSREGISTER,0		
		
		btfss	ESUHILFSREGISTER,0
		goto	UPLSBEEP
 
		btfss	ESUKONFIG,LSEINAUS
		goto	UPLSBEEP

		btfss 	ESUSTATUS,2	
		goto	UPLSBEEP
		btg	PORTC,0
		 
		;Beepton
UPLSBEEP	btfss	ESUHILFSREGISTER,1
		goto	UPLSENDE
		bcf	ESUHILFSREGISTER,1
		bcf	PORTC,0

UPLSENDE	return


;**********************************************************************************************
;** TASTENROUTINE									     **
;** Diese Routine wird alle 4ms vom Hauptprogramm aufgerufen				     **
;**											     **
;** Aufgabe: Ermittelt welche freigegebene Taste gedrueckt wurde und ruft das dazugehoerige  **
;**	Unterprogramm auf.								     **
;**											     **
;** Allgemeines: Die Tasten sind am Port D mit je einem Pull-Up-Widerstand angeschlossen.    **
;**	Im Ruhezustand (Taste nicht gedrueckt) liegt an dem Portpin ein High-Pegel. Durch    **
;**	Druecken der Taste wird dieser Portpin auf Masse gelegt (Low-Pegel). Dieses Verhalten**
;**	wird auch als Lowaktiv bezeichnet.						     **
;**											     **
;** Vorgehensweise: 									     **
;**	+ Port D einlesen und im Register TEMP6 sichern.				     **					     **
;**	+ Das Register ESUTASTENE beinhaltet zu jeder Taste das Freigabeflag, wobei hier die **
;**	  selbe Bitzuordnung wie am Port D gilt:					     **
;** 		Bit 0:	Taste SELPOS							     **
;**		Bit 1:	Taste SELZEIT							     **
;**		Bit 2:	Taste PAUSE							     **
;**		Bit 3:	Taste START							     **
;**		Bit 4:	Taste STOP							     **
;**		Bit 5:	Taste ZEIT+							     **
;**	  Bei einer freigegebene Taste ist das Bit (Flag) gesetzt (= 1), bei einer gesperrten**
;**	  Taste ist es zurueckgesetzt (= 0)						     **	
;**	+ Das Register ESUTASTENALT gibt beim Aufruf den Zustand der Tasten an, welcher beim **
;**	  vorhergehenden Aufruf dieses Unterprogrammes am Port D herrschte. (Also den Zustand**
;**	  am Port D vor 4ms)								     **
;**	+ Mit Hilfe der beiden Register TEMP6 und ESUTASTENALT laesst sich somit 	     **
;**       ermitteln ob eine bestimmte Taste zwischen dem vorhergehenden Aufruf dieses Unter- **
;**	  programmes und den gerade bearbeitenden Aufruf gedrueckt wurde. Mit diesem 	     **
;**	  Verfahren wird auch gleichzeitig das sogenannte Tastenprellen ueberbrueckt, da     **
;**	  dieses Tastenprellen in der Regel weit weniger als 4ms dauert.		     **
;**	  Die Befehlsfolge	comf	TEMP6,w						     **
;**				andwf	ESUTASTENE,w					     **
;**				andwf	ESUTASTENALT,f					     **
;**	  prueft also, ob eine Taste gedrueckt wurde und ob diese freigegeben ist. Dazu      **
;**	  muessen folgende Bedingungen gelten:						     **
;**			    	TEMP6,x		0 (Low)					     **
;**				ESUTASTENALT,x	1 (High)				     **
;**				ESUTASTENE,x	1 (High)				     **
;**	  Das Ergebnis (welche freigegebene Taste gedrueckt wurde) wird in das Register      **
;**	  ESUTASTENALT gesichert. Die Register TEMP6 und ESUTASTENE bleiben dabei unver-     **
;**  	  aendert.  									     **
;**	+ je nachdem welche Bits (Flags) nun im Register ESUTASTENALT gesetzt sind die Unter-**
;**	  programme mit den durchzufuehrenden Anweisungen fuer die gedrueckt Taste aufrufen. **
;**	+ Registerinhalt von TEMP5 in das Register ESUTASTENALT kopieren  		     **
;**	+ Unterprogramm verlassen							     **
;**											     **
;** Achtung: Tasten sind LOWAKTIV!						       	     **
;**											     **
;** Anmerkung: Das temporaere Register TEMP6 wird hier nur zum Zwischenspeichern benoetigt.  **
;**       Es kann daher auch woanders verwendet werden.  				     **
;**********************************************************************************************		
TASTENROUTINE	movf	PORTD,w			;Port D einlesen,
		movwf	TEMP6			;  und in Register TEMP6 kopieren

		btfsc	ESUSTATUS,3		;Sanduhr im Stand-By-Mode?
		goto	UPTASTENSTANDBYAUS	;ja: Sanduhr nur "aufwecken", wenn eine Taste
						;  gedrueckt
 
		comf	TEMP6,w			;nein: siehe obige Beschreibung  
		andwf	ESUTASTENE,w		 
		andwf	ESUTASTENALT,f		

 	 	btfsc	ESUTASTENALT,TASTESELZEIT
		call	TASTSELZEIT		;Taste SELZEIT ist freigegeben und wurde 
						;  gedrueckt
 		btfsc	ESUTASTENALT,TASTEPAUSE
		call	TASTPAUSE		;Taste PAUSE ist freigegeben und wurde 
						;  gedrueckt
		btfsc	ESUTASTENALT,TASTESTART
		call	TASTSTART		;Taste START ist freigegeben und wurde 
						;  gedrueckt
		btfsc	ESUTASTENALT,TASTESTOP
		call	TASTSTOP		;Taste STOP ist freigegeben und wurde 
						;  gedrueckt
 
		goto	UPTASTENENDE

UPTASTENSTANDBYAUS				;Sanduhr aus dem Stand-By-Mode aufwecken,
						;  wenn eine Taste gedrueckt wurde
		comf	TEMP6,w			
		andwf	ESUTASTENALT,w		
		andlw	b'00011110'
		btfss	STAT,Z
		call	STANDBYAUS
 
UPTASTENENDE	movf	TEMP6,w			;TEMP6 in Register ESUTASTENALT kopieren
		movwf	ESUTASTENALT
		return
 		

;**********************************************************************************************
;** Die freigegebene Taste SELZEIT wurde gedrueckt			 		     **
;** Aufgaben: 										     **
;**********************************************************************************************
TASTSELZEIT					;Taste "SELZEIT" wurde gedrueckt:
		btfsc	ESUZEITSTATUS,0
		goto	UPTASTSELZEITW1
		btfsc	ESUZEITSTATUS,1
		goto	UPTASTSELZEITW2
		btfsc	ESUZEITSTATUS,2
		goto	UPTASTSELZEITW3
		goto	UPTASTSELZEITW4

UPTASTSELZEITW1	bcf	ESUZEITSTATUS,0		;  Uebergang: Uhrzeit -> Gesamtzeit 
		bcf	ESUZEITSTATUS,1
		bcf	ESUZEITSTATUS,2
		bsf	ESUZEITSTATUS,4
		goto	UPTASTSELZEITW5
 
UPTASTSELZEITW2	bsf	ESUZEITSTATUS,0		;  Uebergang: Abgel.Zeit -> Uhrzeit
		bcf	ESUZEITSTATUS,1
		bcf	ESUZEITSTATUS,2
		bcf	ESUZEITSTATUS,4
		goto	UPTASTSELZEITW5			 

UPTASTSELZEITW3	bcf	ESUZEITSTATUS,0		;  Uebergang: Verbl.Zeit -> Abgel.Zeit
		bsf	ESUZEITSTATUS,1
		bcf	ESUZEITSTATUS,2
		bcf	ESUZEITSTATUS,4
		goto	UPTASTSELZEITW5

UPTASTSELZEITW4	bcf	ESUZEITSTATUS,0		;  Uebergang: Gesamtzeit -> Verbl.Zeit
		bcf	ESUZEITSTATUS,1
		bsf	ESUZEITSTATUS,2
		bcf	ESUZEITSTATUS,4 


UPTASTSELZEITW5	call	ZEITAUSWAHL
		return


;**********************************************************************************************
;** Die freigegebene Taste PAUSE wurde gedrueckt		 			     **
;**											     **
;** Aufgaben: Das Flag ESUSTATUS,1 gibt an, ob der Rieselvorgang angehalten wurde. Ist der   **
;** 	Rieselvorgang angehalten (ESUSTATUS,1 = 1) so muss dieses fortgesetzt werden         **
;**	(ESUSTATUS,1 = 0). Ist der Rieselvorgang aktiv, so muss nun das Flag ESUSTATUS,1 ge- **
;**	setzt werde, damit der Rieselvorgang angehaltenen wird.				     **
;** 	D.h.: Bei jedem Aufruf dieses Unterprogrammes (durch druecken der freigegebenen Taste**
;**	PAUSE) muss das Flag ESUSTATUS,1 invertiert werden.				     **
;**											     **	
;** Anmerkung: Bei der Anweisung btg handelt es sich um Makro und nicht um einen Assembler-  **
;**	Befehl.										     **
;**********************************************************************************************
TASTPAUSE	btg	ESUSTATUS,1		;Flag "Pause" im Sanduhr-Status-Register  
						;  invertieren
		
		btfsc	ESUSTATUS,1		;Sanduhr im Mode Pause?
		goto	UPTASTPAUSEENDE		;ja: Unterprogramm verlassen

		bcf 	PORTA,EN_LED		;nein: LED-Anzeige und
		bcf	PORTA,EN_ZEIT		;  Zeitanzeige freigeben	

UPTASTPAUSEENDE
		return

	 
;**********************************************************************************************
;** Die freigegebene Taste START wurde gedrueckt		 	 		     **
;** Aufgaben: 										     **
;**********************************************************************************************
TASTSTART	;Pruefen, ob die Eingegebene Gesamtzeit groesser als 4 Sekunden betraegt 	
		movf	ESUZEITGESMIN,f		;Minuten >0?
		btfss	STAT,Z			;ja:  
		goto	TASTSTARTZEITOK		;nein: Sekunden >=6?
		movlw	.6
		subwf	ESUZEITGESSEK,w
		btfss	STAT,C			
		goto	TASTSTARTENDE


TASTSTARTZEITOK	call	ZUSTAND1		;  die oberen LEDs aktivieren

		movlw	ZUSTANZ			;  Die Konstante ZUSTANZ (=Anzahl d. moeglichen
		movwf	ESULEDAKTZUSTAND	;  LED-Zustaende) ins Register ESULEDAKTZUSTAND
						;  kopieren

		call	ZEITZW2ZUSTBER		;  Zeit zwischen 2 LED-Zustaenden berechnen			

		movf	ESULEDZEITZW2ZUST0,w	;  Die berechenten Zeit 
		movwf	ESULEDZAEHLZW2ZUST0	;  den Zaehlregistern zuweisen
		 
		movf	ESULEDZEITZW2ZUST1,w
		movwf	ESULEDZAEHLZW2ZUST1

		movf	ESULEDZEITZW2ZUST2,w
		movwf	ESULEDZAEHLZW2ZUST2

		 	
		movlw	b'00000001'		;  Flag "Starttaste gedrueckt" im Sanduhr-
		movwf	ESUSTATUS		;  Statusregister setzen, alle anderen
						;  Flags in diesem Register loeschen

		movlw	b'00010110'		;  Tasten STOP, PAUSE und SELZEIT freigeben
		movwf	ESUTASTENE		;  Taste START und Inkrementalgeber sperren
					 
		call	SAUSBEISTART		;  die Schaltausgaenge je nach Mode setzen 
						;  oder ruecksetzen


		movf	ESUZEITGESSEK,w		;  verbleibende Zeit = Gesamtzeil
		movwf	ESUZEITBLEIBSEK
		movf	ESUZEITGESMIN,w
		movwf	ESUZEITBLEIBMIN

		clrf	ESUZEITABSEK 		;  abgelaufene Zeit loeschen
		clrf	ESUZEITABMIN	
		

		bcf	ESUZEITSTATUS,0		;  die verbleibende Zeit anzeigen
		bcf	ESUZEITSTATUS,1
		bsf	ESUZEITSTATUS,2
		bcf	ESUZEITSTATUS,4		

 		call	ZEITAUSWAHL

TASTSTARTENDE 	return


;**********************************************************************************************
;** Die freigegebene Taste STOP wurde gedrueckt		 	 	 		     **
;** Aufgaben: 										     **
;**********************************************************************************************
TASTSTOP
		call	ZUSTAND0		 
	
		clrf	ESUSTATUS		;Sanduhr-Statusregister ruecksetzen ...
		clrf	ESUZEITABMIN		;... abgelaufene Zeit loeschen ...		
		clrf	ESUZEITABSEK
		clrf	ESUZEITBLEIBMIN		;... verbleibende Zeit loeschen ...
		clrf	ESUZEITBLEIBSEK

		movlw	b'00101011'		;... Tasten START, SELPOS und Drehimpulsgeber
						;  freigeben...  
		movwf	ESUTASTENE		;... Tasten STOP und PAUSE sperren...

		bcf	ESUZEITSTATUS,0		;... die Gesamtzeit anzeigen ...
		bcf	ESUZEITSTATUS,1
		bcf	ESUZEITSTATUS,2
		bsf	ESUZEITSTATUS,4 
		
		call	ZEITAUSWAHL

		movf	ESUKONFIG,w		;... die Stand-By-Zaehlregister laden ...  
		andlw	b'00001111'
		movwf	ESUSTANDBYMIN
		clrf	ESUSTANDBYSEK

		bsf	PORTA,SCHALTAUSGANG1	;... die Schaltausgaenge deaktivieren (setzen)
		bsf	PORTA,SCHALTAUSGANG2	 
		return					


;**********************************************************************************************
;** Verrieselzeit 		   				 			     **
;** Aufgaben: 										     **
;** Bei jedem Aufruf dieses Unterprogrammes das Zaehlregister fuer die abgelaufene Zeit um   **
;** eine Sekunde erhoehen und das Zaehlregister fuer die verbleibende Zeit um eine Sekunde   **
;** vermindern. Beinhaltet das Zaehlregister fuer die verbleibende Zeit nach der Verminderung**
;** den Wert 0, so ist die eingestellte Zeit abgelaufen. Fertig-Flag im Sanduhr-Status-      **
;** Register setzen, die Taste PAUSE sperren und die restlichen Tasten freigeben und die     **
;** Gesamtzeit anzeigen.								     **				
;**********************************************************************************************
VERRIESELZEIT	incf	ESUZEITABSEK,f			;Sekundenzaehler der abgelaufenen
							;  Zeit um 1 erhoehen		
		movf	ESUZEITABSEK,w
		sublw	.60
		btfss	STAT,Z				;Pruefen, ob Sekunde = 60
		goto	UPVERZEITWEITER1
		clrf	ESUZEITABSEK			;wenn Sekunde=60, Sekunde loeschen
		incf	ESUZEITABMIN,f			;  und Minute um 1 erhoehen

		
UPVERZEITWEITER1		
		movf	ESUZEITBLEIBSEK,w
		btfss	STAT,Z
		goto	UPVERZEITWEITER3
		goto	UPVERZEITWEITER2
	
UPVERZEITWEITER2
		movlw	.59			;Wenn Sekunden = 0 u. Minute ungleich 0
		movwf	ESUZEITBLEIBSEK		;  Sekunde mit 59 laden und
		decf	ESUZEITBLEIBMIN,f	;  Minute um 1 vermindern		
		goto	UPVERZEITWEITER4

UPVERZEITWEITER3
		decf 	ESUZEITBLEIBSEK,f	;Sekunde um 1 vermindern	
		movf	ESUZEITBLEIBSEK,w
		btfss	STAT,Z			;Pruefen, ob Sekunde = 0
		goto	UPVERZEITWEITER4
		movf	ESUZEITBLEIBMIN,w	;Wenn Sekunden = 0, Pruefen, ob 
		btfss	STAT,Z			;  Minute = 0
		goto	UPVERZEITWEITER4
 
		movlw	b'00000100'		;Wenn Minute = 0 und Sekunde = 0: 
		movwf	ESUSTATUS		;  eingestellte Zeit ist verrieselt: 
						;  -> Fertig-Flag im Sanduhr-Status-
						;  Register setzen und alle anderen 
						;  Flags loeschen ...
							
		movlw	b'00111011'		;  ... die Tasten PAUSE sperren, die
		movwf	ESUTASTENE		;  anderen Tasten freigeben ...

		call	SAUSNACHZEIT		;  ... die Schaltausgaenge je nach Mode setzen 
						;  oder ruecksetzen ...

		call 	ZEITGESSPEICHERN	;  ... die Gesamtzeit im EEPROM sichern, 
		 				;  wenn sie sich zu der gespeicherten
						;  Gesamtzeit unterscheidet ...
		 
		bcf	ESUZEITSTATUS,0		;  ... die Gesamtzeit anzeigen ...
		bcf	ESUZEITSTATUS,1
		bcf	ESUZEITSTATUS,2
		bsf	ESUZEITSTATUS,4 

UPVERZEITWEITER4	
		call	ZEITAUSWAHL
UPVERZEITENDE	return


;**********************************************************************************************
;** ZEITGESSPEICHERN		   				 			     **
;** Die Gesamtzeit (Minuten und Sekunden) im EEPROM sichern, wenn sie sich zur gespeicherten **
;** Gesamtzeit unterscheidet. (Die Sekunden in die EEPROM-Speicherzelle 0, die Minuten in die**
;** EEPROM-Speicherstelle 1)								     **
;**********************************************************************************************
ZEITGESSPEICHERN
		movlw	.0			;Die Sekunden der Gesamtzeit 
		call	EEPROMLESEN		;aus dem EEPROM auslesen
		subwf	ESUZEITGESSEK,w		;und mit dem Register ESUZEITGESSEk
		btfsc	STAT,Z			;vergleichen.
		goto	UPZEITSPWEITER1
		bcf	PIR2,EEIF		;Unterscheiden sich diese beiden Werte
		 				;(Zero-Flag ist noch der Subtraktion dieser
						;beiden Werte gesetzt)
		movf	ESUZEITGESSEK,w		;den Wert des Registers ESUZEITGESSEK
		movwf	TEMP2			;in das EEPROM in 
		movlw	.0
		movwf	TEMP1			;die Speicherstelle 0 schreiben.
		call	EEPROMSCHREIBEN
UPZEITSPSCHL1	btfss	PIR2,EEIF		;Warten bis das EEPROM mit dem schreiben
		goto	UPZEITSPSCHL1		;fertig ist
		 
UPZEITSPWEITER1	movlw	.1			;Die Minuten der Gesamtzeit 
		call	EEPROMLESEN		;aus dem EEPROM auslesen
		subwf	ESUZEITGESMIN,w		;und mit dem Register ESUZEITGESMIN
		btfsc	STAT,Z			;vergleichen.
		goto	UPZEITSPENDE
		bcf	PIR2,EEIF		;Unterscheiden sich diese beiden Werte
		 				;(Zero-Flag ist noch der Subtraktion dieser
						;beiden Werte gesetzt)
		movf	ESUZEITGESMIN,w		;den Wert des Registers ESUZEITGESMIN 
		movwf	TEMP2			;in das EEPROM in 
		movlw	.1
		movwf	TEMP1			;die Speicherstelle 1 schreiben.
		call	EEPROMSCHREIBEN
UPZEITSPSCHL2	btfss	PIR2,EEIF		;Warten bis das EEPROM mit dem schreiben
		goto	UPZEITSPSCHL2		;fertig ist
UPZEITSPENDE	return


;**********************************************************************************************
;** Sekundentaetigkeiten	   				 			     **
;** Aufgabe:										     **
;** 	+ Fuer den Fall dass kein gueltiges DCF-Telegramm empfangen werden kann sorgt dieses **
;**	Unterprogramm dafuer, dass die Uhrzeit trotzdem jede Sekunde aktualisiert wird. Ist  **
;**	fuer eine laengere Zeit kein korrekter DCF-Empfang moeglich, so wuerden die Minuten, **
;**	Stunden, Tage usw. stehen bleiben, da ja im Unterprogramm DCFUPMINUTE nur gueltige   **
;**	DCF-Telegramme uebernommen werden. 						     **
;**	Dieses Unterprogramm wird also parallel zu den Unterprogrammen fr die DCF-Dekod-    **
;**	ierung aufgerufen.								     **
;**	+ Stand-By-Pruefung
;**	+ weiter Sekundentaetigkeiten							
;**											     **
;** Vorgehensweise:									     **
;** 	+ Die Sekunden (Register UHRSEKUNDE) um 1 erhoehen. Beinhalte dieses Register nun den**
;**	Wert 60, so beginnt eine neue Minute. Daher die Sekunden loeschen und die Minuten    **
;**	(Register UHRMINUTE) um 1 erhoehen. Beinhaltet dieses Register nun den Wert 60, so   **
;**	beginnt eine neue Stunde. Daher die Minuten loeschen und die Stunden (Register       **
;**	UHRSTUNDE) um 1 erhoehen. Beinhaltet dieses Register nun den Wert 24, so beginnt ein **
;**	neuer Tag. Daher die Stunden loeschen. Ist das Mitzaehlen des Datums notwendig, so   **
;**	muss nun ein Register fuer den Tag (zB. DATUMTAG) um 1 erhoeht werden und dieses     **
;**	Ueberprueft werden, wobei diese Pruefung nun nicht mehr so einfach ist, da ja jeder  **
;**	Monat unterschiedlich viele Tage besitzt. Erschwerend kommt auch noch hinzu, dass    **
;**	auch die Schaltjahre miteinbezogen werden muessen!				     **  							
;**     + blabla
;** 											     **		
;** Achtung: 										     **
;**	Dieses Unterprogramm muss daher jede Sekunde aufgerufen werden                       **
;**********************************************************************************************
SEKTAETIGKEITEN
		;Uhrzeit (innere Uhr)
		 
		incf	UHRSEKUNDE,f			;Sekundenzaehler um 1 erhoehen
		movf	UHRSEKUNDE,w
		sublw	.60	
		btfss	STAT,Z				;Pruefen, ob Sekunde = 60
		goto	UPSEKTAETWEITER1		
		clrf	UHRSEKUNDE			;Wenn Sekunde=60, Sekunde loeschen
		incf	UHRMINUTE,f			;  und Minute um 1 erhoehen
		movf	UHRMINUTE,w
		sublw	.60
		btfss	STAT,Z				;Pruefen, ob Minute = 60
		goto	UPSEKTAETWEITER1
		clrf	UHRMINUTE			;wenn Minute=60, Minute loeschen
		incf	UHRSTUNDE,f			;  und Stunde erhoehen
		movf	UHRSTUNDE,w
		sublw	.24
		btfss	STAT,Z				;Pruefen, ob Stunde = 24
		goto	UPSEKTAETWEITER1
		clrf	UHRSTUNDE			;Wenn Stunde=24, Stunde loeschen

		;Stand-By-Pruefung
UPSEKTAETWEITER1		
		movf	ESUSTATUS,f
		btfss	STAT,Z
		goto	UPSEKTAETWEITER4
 		
		movf	ESUSTANDBYSEK,f
		btfss	STAT,Z
		goto	UPSEKTAETWEITER3
		goto	UPSEKTAETWEITER2
	
UPSEKTAETWEITER2
		movlw	.59			;Wenn Sekunden = 0 u. Minute ungleich 0
		movwf	ESUSTANDBYSEK		;  Sekunde mit 59 laden und
		decf	ESUSTANDBYMIN,f		;  Minute um 1 vermindern		
		goto	UPSEKTAETWEITER4

UPSEKTAETWEITER3
		decf 	ESUSTANDBYSEK,f		;Sekunde um 1 vermindern	
		movf	ESUSTANDBYSEK,w
		btfss	STAT,Z			;Pruefen, ob Sekunde = 0
		goto	UPSEKTAETWEITER4
		movf	ESUSTANDBYMIN,w		;Wenn Sekunden = 0, Pruefen, ob 
		btfss	STAT,Z			;  Minute = 0
		goto	UPSEKTAETWEITER4
 
		bsf	ESUSTATUS,3		;Wenn Minute = 0 und Sekunde = 0: 
						;  Stand-By-Mode aktiviren (ESUSTATUS,3 = 1		 
		bsf 	PORTA,EN_LED		;  LED-Anzeige sperren	 
		bsf	ESUZEITSTATUS,0		;  und Uhrzeit anzeigen
		bcf	ESUZEITSTATUS,1
		bcf	ESUZEITSTATUS,2
		bcf	ESUZEITSTATUS,4

		;weitere Sekundentaetigkeiten
UPSEKTAETWEITER4		
		call	ZEITAUSWAHL

		btfsc	ESUSTATUS,1
		goto	UPSEKTAETWEITER5

;		bcf 	PORTA,EN_LED			;LED-Anzeige freigeben
;		bcf	PORTA,EN_ZEIT			;Zeitanzeige freigeben	
	
		btg	ESUZEITSTATUS,3			;Sekundentakt (Leuchtdioden D106 und
							;  D107 toggeln 
		goto	UPSEKTAETENDE

UPSEKTAETWEITER5
		bsf	ESUZEITSTATUS,3
		btg 	PORTA,EN_LED			;LED-Anzeige invertieren
		btg	PORTA,EN_ZEIT			;Zeitanzeige invertiern

UPSEKTAETENDE	return


;**********************************************************************************************
;** Zeit (= Anzahl der ISR-Aufrufe) zwischen zwei LED-Zustaenden berechnen:           	     **
;** Aufgaben:										     **
;** Aus der Gesamtzeit (Register ESUZEITGESMIN und ESUZEITGESSEK) die Zeit d.h. die Anzahl   **
;** der ISR-Aufrufe (222.2222us) berechnen. Das Ergebnis in die Register ESULEDZEITZW2ZUST0  **
;** bis ESULEDZEITZW2ZUST2 kopieren.							     **
;**											     **
;** ESULEDZEITZW2ZUSTx = 19.8 * (ESUZEITGESSEK + 60 * ESUZEITGESMIN)			     **
;**											     **
;** Anmerkung: Die temporaeren Register TEMP1 bis TEMP3 werden hier nur zum Zwischenspeichern**
;**	bzw. als Hilfsregister benoetigt. Sie koennen daher auch woanders verwendet werden.  **
;**********************************************************************************************
ZEITZW2ZUSTBER
		;Schritt 1: Minuten in Sekunden umrechnen
		movlw	.60
		movwf	TEMP1
		clrf	TEMP2
		clrf	TEMP3
UPZEITBERSCHL1	movf	ESUZEITGESMIN,w
		addwf	TEMP2,f			;TEMP2 = TEMP2 + ESUZEITGESMIN
		btfsc	STAT,C
		incf	TEMP3,f		
		decfsz	TEMP1,f
		goto	UPZEITBERSCHL1
		 
		;Schritt 2: Sekunden hinzuaddieren
 		movf	ESUZEITGESSEK,w
		addwf	TEMP2,f			;TEMP2 = TEMP2 + ESUZEITGESSEK
		btfsc	STAT,C
		incf	TEMP3,f	


		;zum Testen - Start
;		bank1
;UPZEIZBERWARTE1	btfss	TXSTA,TRMT
;		goto	UPZEIZBERWARTE1
;		bank0
;		movf	TEMP3,w	   		 
;		movwf	TXREG

;		bank1
;UPZEIZBERWARTE2	btfss	TXSTA,TRMT
;		goto	UPZEIZBERWARTE2
;		bank0
;		movf	TEMP2,w	 		 
;		movwf	TXREG
		;zum Testen - Ende


		;Schritt 3: Sekunden mit dem Faktor 17.6 multiplizieren
		;Schritt 3a: Sekunden mit dem Faktor 0.6 multiplizieren
		movlw	KONSTMUL2
		movwf	TEMP1
		clrf	ESULEDZEITZW2ZUST0
		clrf	ESULEDZEITZW2ZUST1
		clrf	ESULEDZEITZW2ZUST2
UPZEITBERSCHL2	movf	TEMP2,w	
		addwf	ESULEDZEITZW2ZUST0,f	;ESULEDZEITZW2ZUST0=ESULEDZEITZW2ZUST0+TEMP2
		btfss	STAT,C
		goto	UPZEITBERWEITER1
		movlw	.1
		addwf	ESULEDZEITZW2ZUST1,f		
		btfsc	STAT,C
		incf	ESULEDZEITZW2ZUST2,f
UPZEITBERWEITER1
		movf	TEMP3,w
		addwf	ESULEDZEITZW2ZUST1,f	;ESULEDZEITZW2ZUST1=ESULEDZEITZW2ZUST1+TEMP2
		btfsc	STAT,C
		incf	ESULEDZEITZW2ZUST2,f	
 		decfsz	TEMP1,f
		goto	UPZEITBERSCHL2
		movf	ESULEDZEITZW2ZUST1,w
		movwf	ESULEDZEITZW2ZUST0
		movf	ESULEDZEITZW2ZUST2,w
		movwf	ESULEDZEITZW2ZUST1
		clrf	ESULEDZEITZW2ZUST2	


		;zum Testen - Start
;		bank1
;UPZEIZBERWARTE6	btfss	TXSTA,TRMT
;		goto	UPZEIZBERWARTE6
;		bank0
;		movf	ESULEDZEITZW2ZUST1,w	   		 
;		movwf	TXREG

;		bank1
;UPZEIZBERWARTE7	btfss	TXSTA,TRMT
;		goto	UPZEIZBERWARTE7
;		bank0
;		movf	ESULEDZEITZW2ZUST0,w 		 
;		movwf	TXREG
		;zum Testen - Ende
	

		;Schritt 3b: Sekunden mit dem Faktor 17 multiplizieren und hinzuaddieren
		movlw	KONSTMUL1
		movwf	TEMP1
UPZEITBERSCHL3	movf	TEMP2,w
		addwf	ESULEDZEITZW2ZUST0,f	;ESULEDZEITZW2ZUST0=ESULEDZEITZW2ZUST0+TEMP2
 		btfss	STAT,C
		goto	UPZEITBERWEITER2
		movlw	.1
		addwf	ESULEDZEITZW2ZUST1,f		
		btfsc	STAT,C
		incf	ESULEDZEITZW2ZUST2,f
UPZEITBERWEITER2		
		movf	TEMP3,w
		addwf	ESULEDZEITZW2ZUST1,f	;ESULEDZEITZW2ZUST1=ESULEDZEITZW2ZUST1+TEMP2

		btfsc	STAT,C
		incf	ESULEDZEITZW2ZUST2,f		

		decfsz	TEMP1,f
		goto	UPZEITBERSCHL3
		 
		incf	ESULEDZEITZW2ZUST1,f
		incf	ESULEDZEITZW2ZUST2,f


		;zum Testen - Start
;		bank1
;UPZEIZBERWARTE3	btfss	TXSTA,TRMT
;		goto	UPZEIZBERWARTE3
;		bank0
;		movf	ESULEDZEITZW2ZUST2,w	   		 
;		movwf	TXREG

;		bank1
;UPZEIZBERWARTE4	btfss	TXSTA,TRMT
;		goto	UPZEIZBERWARTE4
;		bank0
;		movf	ESULEDZEITZW2ZUST1,w	 		 
;		movwf	TXREG

;		bank1
;UPZEIZBERWARTE5	btfss	TXSTA,TRMT
;		goto	UPZEIZBERWARTE5
;		bank0
;		movf	ESULEDZEITZW2ZUST0,w	 		 
;		movwf	TXREG
		;zum Testen - Ende


		return


;**********************************************************************************************
;** LED-Zustandswechsel:                                          			     **
;** Aufgaben:										     **
;** Die zu ersetzende LED (LED-Adresse) aus Tabelle TABWIRDERSETZT holen, diese Adresse im   **
;** RAM (ESULEDPOS1, Adresse A0 bis ESULEDPOS51, Adresse D2) suchen und durch die neue LED   **
;** aus Tabelle TABNEUELED ersetzen.	     						     **
;** Wenn bei jedem Zustandswechsel der Lautsprecher ein Beep-Ton ausgeben soll (Bit 6 im     **
;** Register ESUKONFIG gesetzt), den Lautsprecher am Portpin RC2 einschalten. Ausgeschaltet  **
;** wird der Lautsprecher beim naechsten 222.2222s-Takt im Unterprogramm LAUSTPRECHER. Das  **
;** Bit 1 im Register ESUHILFSREGISTER diehnt daher als Anforderungsflag zum Ausschalten des **
;** Lautsprechers.									     **
;**											     **
;** Anmerkung: Die temporaeren Register TEMP1 und TEMP2 werden hier nur zum Zwischenspeichern**
;**	(TEMP2) bzw. als Hilfsregister (TEMP1) benoetigt. Sie koennen daher auch woanders    **
;**	verwendet werden.			    					     **
;**********************************************************************************************
NAECHSTZUST	
;		movf	ESULEDAKTZUSTAND,f	;Wenn das Register ESULEDAKTZUSTAND den 
;		btfss	STAT,Z			;  Wert 0 beinhaltet diese Unterprogramm
;		goto	UPNAECHSTZUSTENDE	;  ueberspringen	
		 

  		movlw	0xA0			;Adresse von POS1 in  		
		movwf	TEMP1			;Hilfsregister TEMP1 laden
		
		movlw	KONSTTABWIRDERSETZT
		movwf	PCLATH	
		
		movf	ESULEDAKTZUSTAND,w	;die zu ersetzende LED (LEDADRESSE)
		call	TABWIRDERSETZT		;  aus Tabelle TABWIRDERSETZT auslesen	
		movwf	TEMP2			;  und in TEMP2 speichern
	
UPNAECHSTZUSTSCHL1
 		movf	TEMP1,w	
		movwf	FSR
		movf	IND,w			;Tabellenwert (=TEMP2) von IND subtrahieren
		subwf	TEMP2,w
		btfsc	STAT,Z			;Z(ero)-Flag prfen
		goto	UPNAECHSTZUSTWEITER1	;Wenn Z(ero)-Flag gesetzt: TEMP2=IND -> LED,
						;  auf Welche das FSR zeigt austauchen
		incf	TEMP1,f			;Wenn Z(ero)-Flag nicht gesetzt: TEMP1 
		goto	UPNAECHSTZUSTSCHL1	;  erhoehen und Vorgang weiderholen
 
UPNAECHSTZUSTWEITER1			
		movlw	KONSTTABNEUELED
		movwf	PCLATH		

 		movf	ESULEDAKTZUSTAND,w	;Die neue LED (LEDADRESSE)
		call	TABNEUELED		;  aus Tabelle TABNEUELED auslesen
		movwf	IND			;  und an die Position der zuvor gesuchten
						;  Speicherstelle schreiben.
	 	
		clrf	PCLATH 

		decf	ESULEDAKTZUSTAND,f	;Zustandszaehler um 1 erniedrigen
;		decfsz	ESULEDAKTZUSTAND,f		;Zustandszhler um 1 erniedrigen
;		goto	FLAGLOESCHEN
;		bsf	ESUSTATUS,2		;FertigFlag setzen und
;		bcf	ESUSTATUS,0		;LED-rieseln-Status-Bit lschen	
;FLAGLOESCHEN	
;		bcf	ESUSTATUS,1		;NaechstZust-Flag wieder loeschen

 		
		btfss	ESUKONFIG,BEEPEINAUS	;wenn Beep eingeschaltet (Flag BEEPEINAUS im
						;  Register ESUKONFIG gesetzt)
		goto 	UPNAECHSTZUSTENDE
		bsf	PORTC,0			;Lautprecher fuer einen kurzen Beep-Ton 
						;  einschalten  
 		bsf	ESUHILFSREGISTER,1	;zum Ausschalten des Lautsprechers ein
						;  Hilfsflagsflag setzen 
UPNAECHSTZUSTENDE
 		return


;**********************************************************************************************
;** Stand-By-Mode beenden					 			     **
;**********************************************************************************************
STANDBYAUS	bcf	ESUSTATUS,3		;Stand-By-Flag loeschen,
		bcf	PORTA,EN_LED		;LED-Anzeige wieder freigeben,
		bcf	ESUZEITSTATUS,0		;Gesamtzeit anzeigen
		bcf	ESUZEITSTATUS,1
		bcf	ESUZEITSTATUS,2
		bsf	ESUZEITSTATUS,4

		movf	ESUKONFIG,w		;die Stand-By-Zaehlregister neu laden  
		andlw	b'00001111'
		movwf	ESUSTANDBYMIN
		clrf	ESUSTANDBYSEK
		return


;******************************** Schaltausgang-Routinen **************************************

;**********************************************************************************************
;** Schaltausgang beim Druecken der Starttaste je nach Modus setzen oder ruecksetzen         **
;** Das dazugehoerige Register (ESUKONFIGSAUS1 fuer Schaltausgang 1 bzw. ESUKONFIGSAUS2 fuer **
;** Schaltausgang 2 ist wie folgt definiert:						     **
;**	Bit 7	Bit 6  	Funktion							     **
;**	  0	  0	Mode 0 (kein Schaltausgang, Schaltausgang bleibt gesetzt)	     **
;**	  0	  1     Mode 1 (beim Start: Schaltausgang ruecksetzen)  		     **
;**	  1	  0     Mode 2 (beim Start: Schaltausgang setzen)  	             	     **
;**	  1	  1     Mode 3 (beim Start: Schaltausgang setzen)     			     **
;**											     **
;**  	Bit 0 bis 5:	sind hier nicht von Bedeutung, diese werden erst nach Ablauf der Zeit**
;**			fuer Mode 3 benoetigt.					             ** 
;**********************************************************************************************
SAUSBEISTART
		;Schaltausgang 1
		btfsc 	ESUKONFIGSAUS1,7
		goto	SAUSBEISTARTSETZEN1
		btfss 	ESUKONFIGSAUS1,6		;Schaltausgang 1 im Mode 1?
		goto	SAUSBEISTARTSETZEN1
		bcf	PORTA,SCHALTAUSGANG1		;ja: Schaltausgang 1 ruecksetzen
		goto	SAUSBEISTARTW1

SAUSBEISTARTSETZEN1
		bsf	PORTA,SCHALTAUSGANG1		;nein: Schaltausgang 1 setzen
		 

		;Schaltausgang 2
SAUSBEISTARTW1
		btfsc 	ESUKONFIGSAUS2,7
		goto	SAUSBEISTARTSETZEN2
		btfss 	ESUKONFIGSAUS2,6		;Schaltausgang 2 im Mode 1?
		goto	SAUSBEISTARTSETZEN2
		bcf	PORTA,SCHALTAUSGANG2		;ja: Schaltausgang 2 ruecksetzen
		goto	SAUSBEISTARTENDE

SAUSBEISTARTSETZEN2
		bsf	PORTA,SCHALTAUSGANG2		;nein: Schaltausgang 2 setzen
		 
SAUSBEISTARTENDE
		return


;**********************************************************************************************
;** Schaltausgang nach Ablauf der Zeit je nach Modus setzen oder ruecksetzen         	     **
;** Das dazugehoerige Register (ESUKONFIGSAUS1 fuer Schaltausgang 1 bzw. ESUKONFIGSAUS2 fuer **
;** Schaltausgang 2 ist wie folgt definiert:						     **
;**	Bit 7	Bit 6  	Funktion							     **
;**	  0	  0	Mode 0 (kein Schaltausgang, Schaltausgang bleibt gesetzt)            **
;**	  0	  1     Mode 1 (nach Ablauf der Zeit: setzen)       		   	     **
;**	  1	  0     Mode 2 (nach Ablauf der Zeit: ruecksetzen)       		     **
;**	  1	  1     Mode 3 (nach Ablauf der Zeit: kurzer Low-Impuls, die Impulszeit wird **
;**			       dabei von den Bits 0 bis 5 bestimmt)      		     **
;**										             **
;**  	Bit 0 bis 5:	Impulszeit fuer Mode 3 (Impulszeit = Wert aus den Bits 0 - 5 x 250us **
;**			Bit Bit Bit Bit Bit Bit 	Wert				     ** 
;**			 5   4   3   2   1   0					 	     **
;**		   	 0   0   0   0   0   0		 1 x 250us =  0.25ms 	  	     **
;**			 0   0	 0   0	 0   1    	 2 x 250us =  0.50ms 	   	     **
;**			 0   0	 0   0	 1   0 	 	 3 x 250us =  0.75ms 	     	     **
;**			 .   .	 .   .	 .    				  	     	     **
;**			 1   1	 1   1	 1   0 		63 x 250us = 15.75ms 	     	     **
;**			 1   1	 1   1	 1   1 		64 x 250us = 16.00ms 	      	     **
;**********************************************************************************************
SAUSNACHZEIT
		;Schaltausgang 1
		btfss 	ESUKONFIGSAUS1,7
		goto	SAUSNACHZEITSETZEN1
		btfss 	ESUKONFIGSAUS1,6		;Schaltausgang 1 im Mode 1?
		goto	SAUSNACHZEITMODE21
		goto	SAUSNACHZEITMODE31

		;Mode 0,1: Schaltausgang setzen
SAUSNACHZEITSETZEN1
		bsf	PORTA,SCHALTAUSGANG1		;Schaltausgang 1 setzen
		goto	SAUSNACHZEITW1
		
		;Mode 2: Schaltausgang ruecksetzen
SAUSNACHZEITMODE21		
		bcf	PORTA,SCHALTAUSGANG1		;Schaltausgang 1 ruecksetzen
		goto	SAUSNACHZEITW1

		;Mode 3
SAUSNACHZEITMODE31
		bcf	PORTA,SCHALTAUSGANG1		;Schaltausgang 1 ruecksetzen
		movf	ESUKONFIGSAUS1,w		;und Zaehlregister fuer die Impulszeit
		andlw	b'00111111'			;laden
		movwf	SAUS1MODE3ZAEHL
		incf	SAUS1MODE3ZAEHL,f		;und um 1 erhoehen

		;Schaltausgang 2
SAUSNACHZEITW1
		btfss 	ESUKONFIGSAUS2,7
		goto	SAUSNACHZEITSETZEN2
		btfss 	ESUKONFIGSAUS2,6		;Schaltausgang 2 im Mode 1?
		goto	SAUSNACHZEITMODE22
		goto	SAUSNACHZEITMODE32

		;Mode 0,1: Schaltausgang setzen
SAUSNACHZEITSETZEN2
		bsf	PORTA,SCHALTAUSGANG2		;Schaltausgang 2 setzen
		goto	SAUSNACHZEITENDE
		
		;Mode 2: Schaltausgang ruecksetzen
SAUSNACHZEITMODE22		
		bcf	PORTA,SCHALTAUSGANG2		;Schaltausgang 2 ruecksetzen
		goto	SAUSNACHZEITENDE

		;Mode 3
SAUSNACHZEITMODE32
		bcf	PORTA,SCHALTAUSGANG2		;Schaltausgang 2 ruecksetzen
		movf	ESUKONFIGSAUS2,w		;und Zaehlregister fuer die Impulszeit
		andlw	b'00111111'			;laden
		movwf	SAUS2MODE3ZAEHL
		incf	SAUS2MODE3ZAEHL,f		;und um 1 erhoehen

SAUSNACHZEITENDE		
		return


;**********************************************************************************************
;** Impulszeit fuer Mode 3 erzeugen							     **
;**********************************************************************************************
SAUSMODE3
		;Schaltausgang 1
		movf	SAUS1MODE3ZAEHL,f
		btfsc	STAT,Z
		goto	SAUSMODE3W1

		decfsz	SAUS1MODE3ZAEHL,f
		goto	SAUSMODE3W1
		bsf	PORTA,SCHALTAUSGANG1		;Schaltausgang 1 deaktivieren (setzen)

		;Schaltausgang 2
SAUSMODE3W1
		movf	SAUS2MODE3ZAEHL,f
		btfsc	STAT,Z
		goto	SAUSMODE3ENDE

		decfsz	SAUS2MODE3ZAEHL,f
		goto	SAUSMODE3ENDE
		bsf	PORTA,SCHALTAUSGANG2		;Schaltausgang 2 deaktivieren (setzen)

SAUSMODE3ENDE	return


;******************************** Weitere, allgemeine Routinen ********************************

;**********************************************************************************************
;** Umwandlung von Binaer nach BCD				 			     **
;** Aufgabe: 										     **
;**	Die im w-Register stehende Binaer-Zahl (0-255) nach BCD umwandeln. Die einzelnen     **
;**	Ziffern werden zunaechst in temporaere register (TEMP1 bis TEMP3) gespeichert und zu **
;**     Programmende werden die Einer- und Zehnerstelle wieder in das w-Register kopiert     **
;**     (Zehnerstelle im H-Nibble, Einerstelle im L-Nibble). Wird die Hunderterstelle        **
;**     benoetigt, so muss das temporaere Register TEMP3 in ein entsprechendes Register      **
;**     kopiert werden.									     **
;**											     **
;** Vorgehensweise:									     **
;**	+ Von der Zahl wird 10 so oft abgezogen, bis der Rest kleiner 10 ist, bei jeder      **
;**	  Subtraktion wird TEMP2 (Zehnerstelle) um 1 erhoeht. Ist TEMP2 (Zehnerstelle) = 10  **
;**	  wird TEMP3 (Hunderterstelle) um 1 erhoeht und TEMP2 (Zehnerstelle) zu 0 gemacht.   **
;**     + Ergebnis in w								 	     **
;**											     **
;** Anmerkung: 										     **
;**	Die temporaeren Register TEMP1 bis TEMP3 werden hier nur zum Zwischenspeichern       **
;**	benoetigt. Sie koennen daher auch woanders verwendet werden.			     ** 	  
;**********************************************************************************************
BINBCD2		clrf	TEMP3			;TEMP3 loeschen (Hunderter)
 		clrf	TEMP2			;TEMP2 loeschen	(Zehner)
		movwf	TEMP1			;w in TEMP1 (Einer)	
BinBCDWdh	movlw	.10			
		subwf	TEMP1,w			;TEMP1 - 10 in w
		btfss	STAT,C			;TEMP1 < 10 ?
		goto	BinBCDfertig		;  ja: Ruecksprung
		movwf	TEMP1			;  nein: (TEMP1 - 10) in TEMP1
		incf	TEMP2,f			;TEMP2 + 1
		movlw	.10			
		subwf	TEMP2,w
		btfss	STAT,C			;TEMP2 = 10 ?
		goto	BinBCDWdh		;  nein: wiederholen
		clrf	TEMP2			;  ja: TEMP2 = 0
		incf	TEMP3,f			;    und TEMP3 + 1
		goto	BinBCDWdh

BinBCDfertig 	swapf	TEMP2,w			;TEMP2 in Hi-Nibble
		iorwf	TEMP1,w			;TEMP1 in Lo-Nibble
		return


;**********************************************************************************************	
;** Umwandlung von BCD nach Binaer:		 					     **
;** Aufgabe: 										     **
;**	+ Die im w-Register stehende 2-stellige-BCD-Zahl nach Binr umwandlen		     **
;**											     **
;** Vorgehensweise:									     **
;**	+ Die umzuwandelnde BCD-Zahl im temporaeren Register TEMP1 zwischenspeichern	     **
;**	+ w-Register (Arbeitsregister) loeschen. 		    			     **
;**	+ Die BCD-Zahl bitweise ueberpruefen. 						     **
;**	    zB: BCD-Zahl: 0010 0110  (= 26)						     **
;**			  |||| |||| 							     **
;**			  |||| ||| -   0  ( = 0 x 1)					     **	
;** 			  |||| || -- + 2  ( = 1 x 2)					     **
;**			  |||| | --- + 4  ( = 1 x 4)				  	     **
;**		          ||||  ---- + 0  ( = 0 x 8)					     **
;**			  ||| ------ + 0  ( = 0 x 10)					     ** 
;**			  || ------- +20  ( = 1 x 20)					     **
;**			  | -------- + 0  ( = 0 x 40)					     **
;**			   --------- + 0  ( = 0 x 80)					     **
;**			------------------------------					     **
;**			             =26						     **
;**	+ Ergebnis in w									     **
;**											     **
;** Anmerkung: Das Temporaere Register TEMP1 wird hier nur zum Zwischenspeichern bentigt    **
;**	und kannen daher auch wo anders verwendet werden.		     		     **	 
;**********************************************************************************************
BCDBIN2		movwf	TEMP1		;umzuwandelnde BCD-Zahl zwischenspeichern
		clrw			;Arbeitsregister (w-Register) loeschen
		btfsc	TEMP1,0		;Ist Bit0 der BCD-Zahl gesetzt,	
		addlw	.1		;  zum w-Register den Wert 1 addieren
		btfsc	TEMP1,1		;Ist Bit1 der BCD-Zahl gesetzt,	
		addlw	.2		;  zum w-Register den Wert 2 addieren
		btfsc	TEMP1,2		;Ist Bit2 der BCD-Zahl gesetzt,		
		addlw	.4		;  zum w-Register den Wert 4 addieren
		btfsc	TEMP1,3		;Ist Bit3 der BCD-Zahl gesetzt,		
		addlw	.8		;  zum w-Register den Wert 8 addieren
		btfsc	TEMP1,4		;Ist Bit4 der BCD-Zahl gesetzt,		
		addlw	.10		;  zum w-Register den Wert 10 addieren
		btfsc	TEMP1,5		;Ist Bit5 der BCD-Zahl gesetzt,		
		addlw	.20		;  zum w-Register den Wert 20 addieren
		btfsc	TEMP1,6		;Ist Bit6 der BCD-Zahl gesetzt,		
		addlw	.40		;  zum w-Register den Wert 40 addieren
		btfsc	TEMP1,7		;Ist Bit7 der BCD-Zahl gesetzt,		
		addlw	.80		;  zum w-Register den Wert 80 addieren, im w-Register
					;  befindet sich nun das Ergebnis 
		return


;******************************** Hauptprogramm ***********************************************

;**********************************************************************************************
;** Aufgaben des Hauptprogramms:                                 			     **
;**     + Aufrufen von INIT (Initialisierungen)          		 		     **
;** 	+ Aufruf von ZUSATAND0 (Ausgangszustand)					     **
;** 	+ Interrupt freigeben                                        			     **
;**********************************************************************************************
Beginn		call	INIT			;Initialisierungen
 		call	ZUSTAND0		;Die unteren 51 LEDs leuchten (Ausgangszustand)
		movlw	b'10100000'		;Timer0 freigeben durch
		movwf	INTCON			;Setzen von GIE und T0IE im INTCON Register

HPSCHLEIFE1
 		btfsc	FLAGSISRHP,FLAG2MSEK
		goto	HPWEITER1

; 		btfsc	FLAGSISRHP,FLAG4MSEK
 		btfsc	FLAGSISRHP,FLAG10MSEK
		goto	HPWEITER2

		btfsc	FLAGSISRHP,FLAG1SEK
		goto	HPWEITER3		
 		
		btfsc	FLAGSISRHP,FLAG1SEKRIESELN
		goto	HPWEITER4

		btfsc	FLAGSISRHP,FLAGNAECHSTZUST	
		goto	HPWEITER5

		btfsc	INKRSTATUS,INKRLINKS	
		goto	HPWEITER6

		btfsc	INKRSTATUS,INKRRECHTS	
		goto	HPWEITER7

		btfsc	DCFSTATUS,DCFNEUEMIN 	;Wenn Anforderungsflag DCFNEUEMIN gesetzt
		call	DCFUPMINUTE		;Unterprogramm DCFUPMINUTE ausfuehren
		btfsc	DCFSTATUS,DCFNEUESEK 	;Wenn Anforderungsflag DCFNEUESEK gesetzt
		call	DCFUPSEKUNDE		;Unterprogramm DCFUPSEKUNDE ausfuehren

		goto	HPSCHLEIFE1


HPWEITER1					;Taetigkeiten, die alle 2 ms durchgefuehrt
						;  werden muessen
		call	ZEITANZEIGE
  		bcf	FLAGSISRHP,FLAG2MSEK
		goto	HPSCHLEIFE1

HPWEITER2					;Taetigkeiten, die alle 10 ms durchgefuehrt
						;  werden muessen
		call	INKRROUTINE
		call	DCFROUTINE
 		call	TASTENROUTINE 
   		bcf	FLAGSISRHP,FLAG10MSEK
;  		bcf	FLAGSISRHP,FLAG4MSEK
		goto	HPSCHLEIFE1

HPWEITER3					;Taetigkeiten, die jede Sekunde durchgefuehrt
						;  werden muessen
		call	SEKTAETIGKEITEN
	 
		bcf	FLAGSISRHP,FLAG1SEK
		goto	HPSCHLEIFE1

HPWEITER4
		call	VERRIESELZEIT
		bcf	FLAGSISRHP,FLAG1SEKRIESELN
		goto	HPSCHLEIFE1

HPWEITER5
		call	NAECHSTZUST
		bcf	FLAGSISRHP,FLAGNAECHSTZUST
		goto	HPSCHLEIFE1

HPWEITER6
 		call	INKRLINKSDREHUNG
		bcf	INKRSTATUS,INKRLINKS
		goto	HPSCHLEIFE1

HPWEITER7
 		call	INKRRECHTSDREHUNG
		bcf	INKRSTATUS,INKRRECHTS
		goto	HPSCHLEIFE1

 
;******************************** Tabellen ****************************************************

		ORG	0x600 
;**********************************************************************************************
;** Tabelle TABWIRDERSETZT:     					     		     **
;** blabla		     **
;**********************************************************************************************
TABWIRDERSETZT	addwf	PCL,f
 	 	nop
		dt	LED50
		dt	LED49
		dt	LED53,LED48 
		dt	LED52,LED46 
		dt	LED56,LED53,LED45
		dt	LED54,LED52,LED42
		dt	LED60,LED56,LED53,LED41
		dt	LED57,LED54,LED52,LED37
		dt	LED47
		dt	LED55,LED44 
		dt	LED55,LED43  
		dt	LED59,LED55,LED40 
		dt	LED58,LED55,LED38
		dt	LED64,LED59,LED55,LED36
		dt	LED62,LED58,LED55,LED33
		dt	LED69,LED64,LED59,LED55,LED32
		dt	LED66,LED62,LED58,LED55,LED28
		dt	LED55,LED39
		dt	LED63,LED55,LED35
		dt	LED63,LED55,LED34 
		dt	LED68,LED63,LED55,LED31 
		dt	LED67,LED63,LED55,LED29
		dt	LED73,LED68,LED63,LED55,LED27
		dt	LED71,LED67,LED63,LED55,LED24
		dt	LED78,LED73,LED68,LED63,LED55,LED23
		dt	LED75,LED71,LED67,LED63,LED55,LED19
		dt	LED63,LED55,LED30
		dt	LED72,LED63,LED55,LED26 
		dt 	LED72,LED63,LED55,LED25 
		dt	LED77,LED72,LED63,LED55,LED22 
		dt	LED76,LED72,LED63,LED55,LED20 
		dt	LED82,LED77,LED72,LED63,LED55,LED18 
		dt	LED80,LED76,LED72,LED63,LED55,LED15 
		dt	LED87,LED82,LED77,LED72,LED63,LED55,LED14
		dt	LED84,LED80,LED76,LED72,LED63,LED55,LED10
		dt	LED72,LED63,LED55,LED21 
		dt	LED81,LED72,LED63,LED55,LED17 
		dt	LED81,LED72,LED63,LED55,LED16	
		dt	LED86,LED81,LED72,LED63,LED55,LED13
		dt	LED85,LED81,LED72,LED63,LED55,LED11
		dt	LED91,LED86,LED81,LED72,LED63,LED55,LED9
		dt	LED89,LED85,LED81,LED72,LED63,LED55,LED6
		dt	LED96,LED91,LED86,LED81,LED72,LED63,LED55,LED5
		dt	LED93,LED89,LED85,LED81,LED72,LED63,LED55,LED1
		dt	LED81,LED72,LED63,LED55,LED8
		dt	LED90,LED81,LED72,LED63,LED55,LED7
		dt	LED90,LED81,LED72,LED63,LED55,LED4
		dt	LED95,LED90,LED81,LED72,LED63,LED55,LED2 
		dt	LED94,LED90,LED81,LED72,LED63,LED55,LED12
		dt	LED90,LED81,LED72,LED63,LED55,LED3


		ORG	0x700
;**********************************************************************************************
;** Tabelle TABNEUELED:		     					     		     **
;** blabla		     **
;**********************************************************************************************
TABNEUELED    	addwf	PCL,f
		nop
		dt	LED53
		dt	LED52
		dt	LED56,LED53 
		dt	LED54,LED52 
		dt	LED60,LED56,LED53 
		dt	LED57,LED54,LED52 
		dt	LED65,LED60,LED56,LED53 
		dt	LED61,LED57,LED54,LED52 
		dt	LED55
		dt	LED59,LED55
		dt	LED58,LED55 
		dt	LED64,LED59,LED55 
		dt	LED62,LED58,LED55 
		dt	LED69,LED64,LED59,LED55 
		dt	LED66,LED62,LED58,LED55 
		dt	LED74,LED69,LED64,LED59,LED55 
		dt	LED70,LED66,LED62,LED58,LED55 
		dt	LED63,LED55 
		dt	LED68,LED63,LED55 
		dt	LED67,LED63,LED55 
		dt	LED73,LED68,LED63,LED55 
		dt	LED71,LED67,LED63,LED55 
		dt	LED78,LED73,LED68,LED63,LED55
		dt	LED75,LED71,LED67,LED63,LED55 
		dt	LED83,LED78,LED73,LED68,LED63,LED55 
		dt	LED79,LED75,LED71,LED67,LED63,LED55
		dt	LED72,LED63,LED55 
		dt	LED77,LED72,LED63,LED55 
		dt 	LED76,LED72,LED63,LED55 
		dt	LED82,LED77,LED72,LED63,LED55 
		dt	LED80,LED76,LED72,LED63,LED55 
		dt	LED87,LED82,LED77,LED72,LED63,LED55 
		dt	LED84,LED80,LED76,LED72,LED63,LED55 
		dt	LED92,LED87,LED82,LED77,LED72,LED63,LED55 
		dt	LED88,LED84,LED80,LED76,LED72,LED63,LED55 
		dt	LED81,LED72,LED63,LED55 
		dt	LED86,LED81,LED72,LED63,LED55
		dt	LED85,LED81,LED72,LED63,LED55 
		dt	LED91,LED86,LED81,LED72,LED63,LED55 
		dt	LED89,LED85,LED81,LED72,LED63,LED55 
		dt	LED96,LED91,LED86,LED81,LED72,LED63,LED55 
		dt	LED93,LED89,LED85,LED81,LED72,LED63,LED55 
		dt	LED101,LED96,LED91,LED86,LED81,LED72,LED63,LED55 
		dt	LED97,LED93,LED89,LED85,LED81,LED72,LED63,LED55 
		dt	LED90,LED81,LED72,LED63,LED55 
		dt	LED95,LED90,LED81,LED72,LED63,LED55 
		dt	LED94,LED90,LED81,LED72,LED63,LED55 
		dt	LED100,LED95,LED90,LED81,LED72,LED63,LED55 
		dt	LED98,LED94,LED90,LED81,LED72,LED63,LED55
		dt	LED99,LED90,LED81,LED72,LED63,LED55


;******************************** EEPROM-Inhalt ***********************************************

		ORG	0x2100			 
;**********************************************************************************************
;** EEPROM beim Brennen mit folgenden Werten vorbelegen				     	     **
;**********************************************************************************************
		de	.00			;Gesamtzeit (Sekunden)
		de	.01			;Gesamtzeit (Minuten
		de	b'11000010'		;ESUKONFIG:
		de	b'01111111'		;Schaltausgang 1
		de	b'01111111'		;Schaltausgang 2


		end



